!--------------------------------------------------------------------------
! (c) 1996 thru 2003 by
! Tinman Development Corporation
!                And
! Reichenberger Development Incorporated
! All Rights Reserved World Wide
! ISBN: 0-933735-17-0
! 
!--------------------------------------------------------------------------
TINCALCULATORSTYLE1  FUNCTION (TITLEIN,NUMBERIN,FLATONOFF)  ! Declare Procedure
Number     REAL                 !The current number displayed
Operand    REAL                 !The first operand for +,-,*,/,^ operations
Memory     REAL                 !The value contained in memory
Operation  REAL                 !The field number of the operation key
NewNumber  BYTE                 !True following = or %
Decimal    BYTE                 !True after pressing decimal point key
Digit      BYTE                 !Numeric digit represented by number key
Calculator WINDOW('Calculator'),AT(80,7,110,146),ICON('TINCALC.ICO'),SYSTEM,GRAY,DOUBLE,AUTO
       BUTTON('&0'),AT(30,108,14,12),USE(?Zero),FONT('Arial',12,,),KEY(KeyPad0)
       BUTTON('&1'),AT(30,92,14,12),USE(?One),FONT('Arial',12,,),KEY(KeyPad1)
       BUTTON('&2'),AT(48,92,14,12),USE(?Two),FONT('Arial',12,,),KEY(KeyPad2)
       BUTTON('&3'),AT(66,92,14,12),USE(?Three),FONT('Arial',12,,),KEY(KeyPad3)
       BUTTON('&4'),AT(30,78,14,12),USE(?Four),FONT('Arial',12,,),KEY(KeyPad4)
       BUTTON('&5'),AT(48,78,14,12),USE(?Five),FONT('Arial',12,,),KEY(KeyPad5)
       BUTTON('&6'),AT(66,78,14,12),USE(?Six),FONT('Arial',12,,),KEY(KeyPad6)
       BUTTON('&7'),AT(30,64,14,12),USE(?Seven),FONT('Arial',12,,),KEY(KeyPad7)
       BUTTON('&8'),AT(48,64,14,12),USE(?Eight),FONT('Arial',12,,),KEY(KeyPad8)
       BUTTON('&9'),AT(66,64,14,12),USE(?Nine),FONT('Arial',12,,),KEY(KeyPad9)
       BUTTON('.'),AT(48,108,14,12),USE(?Decimal),FONT('Arial',12,,),KEY(DecimalKey)
       BUTTON('CE'),AT(11,108,14,12),USE(?Clear),FONT('Arial',10,,),TIP('Clear Entry')
       BUTTON('p'),AT(11,78,14,12),USE(?Pi),FONT('Symbol',12,,),TIP('Pi')
       BUTTON('+/-'),AT(11,92,14,12),USE(?Sign),FONT('Arial',10,,),TIP('Reverse Sign')
       BUTTON('x<178>'),AT(48,49,14,12),USE(?Square),FONT('Arial',10,,),TIP('Squared')
       BUTTON(''),AT(30,49,14,12),USE(?Root),FONT('Symbol',12,,),TIP('Square Root')
       BUTTON('1/x'),AT(85,49,14,12),USE(?Reciprical),FONT('Arial',10,,),TIP('Reciprical')
       BUTTON('10X'),AT(11,49,14,12),USE(?TenTimes),FONT('Ariel',10,,),TIP('Multiply by Ten')
       BUTTON('%'),AT(11,64,14,12),USE(?Percent),FONT('Arial',12,,),TIP('Percent')
       BUTTON('CM'),AT(30,34,14,12),USE(?MemClear),FONT('Arial',11,,),TIP('Clear Memory')
       BUTTON(' C'),AT(11,34,14,12),USE(?ClearAll),FONT('Arial',11,,),TIP('Clear All')
       BUTTON('RM'),AT(48,34,14,12),USE(?MemRecall),FONT('Arial',10,,),TIP('Recall Memory')
       BUTTON(' M -'),AT(66,34,14,12),USE(?MemMinus),FONT('Arial',10,,),TIP('Subtract from Memory')
       BUTTON(' M+'),AT(85,34,14,12),USE(?MemPlus),FONT('Arial',10,,),TIP('Add to Memory')
       BUTTON('+'),AT(85,108,14,12),USE(?Add),FONT('Arial',12,,),TIP('Add'),KEY(PlusKey)
       BUTTON('-'),AT(85,92,14,12),USE(?Subtract),FONT('Arial',12,,),TIP('Subtract'),KEY(MinusKey)
       BUTTON('x'),AT(85,78,14,12),USE(?Multiply),FONT('Arial',12,,),TIP('Multiple'),KEY(AstKey)
       BUTTON('/'),AT(85,64,14,12),USE(?Divide),FONT('Arial',12,,),TIP('Divide'),KEY(SlashKey)
       BUTTON('Exp'),AT(66,49,14,12),USE(?Power),FONT('Arial',8,,),TIP('Exponential')
       BUTTON('='),AT(66,108,14,12),USE(?Equal),FONT('Arial',12,,),TIP('Equal'),KEY(EnterKey)
       STRING('Memory:'),AT(9,22,30,10),LEFT
       STRING(@S20),AT(38,22,65,10),USE(Memory),RIGHT,FONT(,8,,)
       ENTRY(@s20),AT(10,6,90,12),USE(Number),RIGHT(3),INS
       BUTTON,AT(11,124),USE(?Cut),ICON(ICON:Copy)
       BUTTON('Select'),AT(37,124,62,20),USE(?Select)
     END
  CODE                                            ! Begin processed code

  OPEN(Calculator)                      !Open the calculator window

  IF ~OMITTED(1) AND TITLEIN THEN
    CALCULATOR{PROP:TEXT} = CLIP(TITLEIN)
  END

  IF ~OMITTED(2) AND NUMBERIN THEN
    NUMBER = NUMBERIN
    NEWNUMBER = FALSE
  ELSE
    NewNumber = True                      !Start with a new number
  END

  LOOP X#=FIRSTFIELD() TO LASTFIELD()
    IF CALCULATOR$X#{Prop:Type} = CREATE:BUTTON AND FLATONOFF THEN
      CALCULATOR$X#{Prop:Flat}  = FLATONOFF
      IF CALCULATOR$X#{Prop:Icon} = '' THEN
        CALCULATOR$X#{Prop:Icon} = 'Blank.ico'
      END
    END
  END

  Decimal = False                       !No decimal point has been entered
  Operation = ?Equal                    !No outstanding operation

  ACCEPT                                !Enable windows and wait for an event
    DISPLAY
    If NewNumber
      First# = 0
    End
    IF ACCEPTED()                         ! user has caused accepted event
      CASE ACCEPTED()                     ! Jump to the accepted field
      OF ?Cut
        SETCLIPBOARD(NUMBER)
      OF ?Select
        BREAK
      OF ?Zero TO ?Nine                   ! For a numeric key
        Digit = ACCEPTED() - ?Zero        !  The digit is the field number
        IF NewNumber                      !  For the first digit
          If Decimal
            Number = '.' & Digit
            NewNumber = False             !   Turn NewNumber flag off
            First# = 1
          Else
            Number = Digit                !   Set the number to the digit
            NewNumber = False             !   Turn NewNumber flag off
            Decimal = False               !   Turn decimal point flag off
          End
        ELSE                              !   For any other digit
          IF Decimal                      !    For a fractional digit
            If First# = 0
              Number = CLIP(Number) & '.' & Digit !     Concatenate the digit
              First# = 1
            ELSE
              Number = CLIP(Number) & Digit !     Concatenate the digit
            End
          ELSE                            !    For an integer digit
            Number = Number * 10 + Digit  !     Multipy by 10 and add the digit
          END                             !    End the IF
        END                               !   End the IF
        CYCLE                             !   Continue number entry
      OF ?Decimal                         ! For the decimal point key
        Decimal = True                    !  Turn decimal point flag on
        CYCLE                             !  Continue number entry
      OF ?Pi                              ! For the Pi key
        Number = 3.141592654              !  Set number to Pi
        NewNumber = TRUE                  !  Start new number
        Decimal = False
        CYCLE                             !  Continue
      OF ?Clear                           ! For the ClearEntry/Clear key
        IF NewNumber THEN                 !  completed number entry
          Operation = ?Equal              !   so Clear current calculation
        END                               !  End IF
        Number = 0                        !  Clear number
        NewNumber = 0                     !  Start new number
        Decimal = False
      END                                 ! End CASE
      IF Operation <> ?Equal              ! Complete outstanding operations
        IF ACCEPTED() = ?Percent          !  For the percent key
          Number = Number * Operand / 100 ! Calculate % value
          IF  (Operation <> ?Add )     |  !  Check not adding
          AND (Operation <> ?Subtract )   !  or subtractiong percentage
            Operation = ?Equal            !   Finished operation
          END                             !  End IF
        END                               ! End IF
        CASE Operation                    !  Jump to saved operation key
        OF ?Add                           ! For Add key
          Number += Operand               !   Add number to operand
        OF ?Subtract                      !  For Subtract key
          Number = Operand - Number       !   Subtract number from operand
        OF ?Multiply                      !  For Multiply key
          Number *= Operand               !   Multiply operand by number
        OF ?Divide                        !  For Divide key
          IF Number <> 0 THEN             !  Check for divide by zero
            Number = Operand / Number     !   Divide operand by number
          END                             !  End IF
        OF ?Power                         !  For Raise to a Power key
          Number = Operand ^ Number       !   Raise operand to number power
        END                               !  End CASE
        Decimal = False
        Operation = ?Equal                !  Operation done
      END;                                ! End IF
      CASE ACCEPTED()                     ! Jump to the accepted field
      OF ?Sign                            ! For the Change Sign key
        Number *= -1                      !  Multiply by -1
      OF ?Square                          ! For the Square key
        Number *= Number                  !  Multilpy by itself
      OF ?Root                            ! For the Square Root key
        Number = SQRT(Number)             !  Find the square root
      OF ?TenTimes                        ! For the 10X key
        Number *= 10                      !  Multiply by 10
      OF ?Reciprical                      ! For the Reciprical key
        IF Number <> 0 THEN               ! Check for divide by zero
          Number = 1/Number               !  Find the reciprical
        END                               ! End IF
      OF ?ClearAll                        ! For clear all key
        Number = 0                        !  Set number to zero
        Memory = 0                        !  Set memory to zero
      OF ?MemClear                        ! For clear memory key
        Memory = 0                        !  Set memory to zero
      OF ?MemRecall                       ! For the Recall Memory key
        Number = Memory                   !  Set number to memory
      OF ?MemMinus                        ! For subtract from memory key
        Memory -= Number                  !  Subtract number from memory
      OF ?MemPlus                         ! For the Add to Memory key
        Memory += Number                  !  Add number to memory
      OF ?Add TO ?Power                   ! For two operand operation keys
        Operation = ACCEPTED()            !  Save the operator
        Operand = Number                  !  Save the first operand
      END                                 ! End CASE
!     SELECT(?Zero)                       ! Set focus to the Zero key
      NewNumber = TRUE                    ! ready for next number
      Decimal = False
    END                                   !End CASE
  END                                   !End ACCEPT
  CLOSE(Calculator)                     !Close the calculater window
  RETURN(NUMBER)

TINCALCULATORSTYLE2  FUNCTION (TITLEIN,NUMBERIN,FLATONOFF)  ! Declare Procedure
Number     string(@s16)         !!!Needs to be a string for proper '0' display
Operand    REAL                 !The first operand for +,-,*,/,^ operations
Memory     REAL                 !The value contained in memory
Operation  REAL                 !The field number of the operation key
NewNumber  BYTE                 !True following = or %
Decimal    BYTE                 !True after pressing decimal point key
Digit      BYTE                 !Numeric digit represented by number key
DecimalFlg BYTE                 !!!decimal flag
RNUMBER    REAL
Calculator WINDOW('Calculator'),AT(,,116,192),FONT('Arial',8,,),CENTER,SYSTEM,GRAY, |
         DOUBLE,AUTO
       BUTTON('&0'),AT(67,125,16,14),FONT('Arial',8,,),KEY(KeyPad0),USE(?Zero)
       BUTTON('&1'),AT(31,109,16,14),FONT('Arial',8,,),KEY(KeyPad1),USE(?One)
       BUTTON('&2'),AT(49,109,16,14),FONT('Arial',8,,),KEY(KeyPad2),USE(?Two)
       BUTTON('&3'),AT(67,109,16,14),FONT('Arial',8,,),KEY(KeyPad3),USE(?Three)
       BUTTON('&4'),AT(31,93,16,14),FONT('Arial',8,,),KEY(KeyPad4),USE(?Four)
       BUTTON('&5'),AT(49,93,16,14),FONT('Arial',8,,),KEY(KeyPad5),USE(?Five)
       BUTTON('&6'),AT(67,93,16,14),FONT('Arial',8,,),KEY(KeyPad6),USE(?Six)
       BUTTON('&7'),AT(31,77,16,14),FONT('Arial',8,,),KEY(KeyPad7),USE(?Seven)
       BUTTON('&8'),AT(49,77,16,14),FONT('Arial',8,,),KEY(KeyPad8),USE(?Eight)
       BUTTON('&9'),AT(67,77,16,14),FONT('Arial',8,,),KEY(KeyPad9),USE(?Nine)
       BUTTON('.'),AT(49,125,16,14),FONT('Arial',8,,),KEY(DecimalKey),USE(?Decimal)
       BUTTON('CE'),AT(9,125,16,14),FONT('Arial',8,,),TIP('Clear'),USE(?Clear)
       BUTTON('p'),AT(49,56,16,14),FONT('Symbol',10,,),TIP('Pi'),USE(?Pi)
       BUTTON('+/-'),AT(31,125,16,14),FONT('Arial',8,,),TIP('Change Sign'),USE(?Sign)
       BUTTON(' x<178>'),AT(67,41,16,14),FONT('Arial',8,,),TIP('Value Squared'),USE(?Square)
       BUTTON(''),AT(67,56,16,14),FONT('Symbol',8,,),TIP('Square Root'),USE(?Root)
       BUTTON('1/x'),AT(13,56,16,14),FONT('Arial',8,,),TIP('Reciprocal'),USE(?Reciprical)
       BUTTON('10X'),AT(31,56,16,14),FONT('Arial',8,,),TIP('Multiply by 10'),USE(?TenTimes)
       BUTTON('%'),AT(90,41,18,16),FONT('Arial',8,,),TIP('Percent'),USE(?Percent)
       BUTTON(' lg'),AT(31,41,16,14),FONT('Arial',8,,),TIP('Base 10 Logarithm'),USE(?Log)
       BUTTON(' ln'),AT(13,41,16,14),FONT('Arial',8,,),TIP('Natural Logarithm'),USE(?Ln)
       BUTTON('MR'),AT(9,77,16,14),FONT('Arial',8,,),TIP('Recall Memory'),USE(?Recall)
       BUTTON('M'),AT(9,93,16,14),FONT('Arial',8,,),TIP('Store in Memory'),USE(?Store)
       BUTTON(' M+'),AT(9,109,16,14),FONT('Arial',8,,),TIP('Add to Memory'),USE(?Accumulate)
       BUTTON('+'),AT(90,116,18,46),FONT('Arial',8,,),TIP('Add'),KEY(PlusKey),USE(?Add)
       BUTTON('-'),AT(90,97,18,16),FONT('Arial',8,,),TIP('Subtract'),KEY(MinusKey),USE(?Subtract)
       BUTTON('x'),AT(90,78,18,16),FONT('Arial',8,,),TIP('Multiply'),KEY(AstKey),USE(?Multiply)
       BUTTON('/'),AT(90,60,18,16),FONT(,8,,),TIP('Divide'),KEY(SlashKey),USE(?Divide)
       BUTTON(' exp'),AT(49,41,16,14),FONT('Arial',8,,),TIP('Exponent'),USE(?Power)
       BUTTON('='),AT(10,143,77,19),FONT('Arial',8,,),KEY(EnterKey),USE(?Equal)
       BUTTON,AT(37,169,71,20),TIP('Exit'),KEY(AltF4),USE(?Exit),ICON('TINEXITS.ICO')
       BUTTON,AT(11,169,22,20),TIP('Copy to Clipboard'),KEY(AltC),USE(?COPY),ICON(ICON:Copy)
       BOX,AT(5,35,107,130),USE(?Box1),ROUND,COLOR(0FFFFH),FILL(0808080H)
       PANEL,AT(28,74,58,67),USE(?Panel1),FILL(0FFFFFFH),BEVEL(1,-1)
       STRING('Memory:'),AT(4,22,30,10),LEFT
       STRING(@S20),AT(34,22,79,10),FONT(,8,,),USE(Memory),LEFT
       ENTRY(@s20),AT(6,4,104,15),FONT('Arial',11,,FONT:bold),USE(Number),RIGHT(1),INS
     END
  CODE                                            ! Begin processed code
  OPEN(Calculator)                        !Open the calculator window

  IF ~OMITTED(1) AND TITLEIN THEN
    CALCULATOR{PROP:TEXT} = CLIP(TITLEIN)
  END

  IF ~OMITTED(2) AND NUMBERIN THEN
    NewNumber = FALSE
    NUMBER    = NUMBERIN
  ELSE
    NewNumber = True                        !Start with a new number
  END

  LOOP X#=FIRSTFIELD() TO LASTFIELD()
    IF CALCULATOR$X#{Prop:Type} = CREATE:BUTTON AND FLATONOFF THEN
      CALCULATOR$X#{Prop:Flat}  = FLATONOFF
      IF CALCULATOR$X#{Prop:Icon} = '' THEN
        CALCULATOR$X#{Prop:Icon} = 'Blank.ico'
      END
    END
  END

  Decimal = False                         !No decimal point has been entered
  Operation = ?Equal                      !No outstanding operation
  DecimalFlg = TRUE                       !!!Set flag

  ACCEPT                                  !Enable windows and wait for an event
    DISPLAY
    IF ACCEPTED()                         ! user has caused accepted event
      CASE ACCEPTED()                     ! Jump to the accepted field
      OF ?EXIT                            !!!Exit Button
        BREAK                             !!!
      OF ?COPY                            !!!Copy to clipboard
        NewNumber = False                 !!!
        SETCLIPBOARD(NUMBER)              !!!
      OF ?Recall                          ! For the Recall Memory key 
        Number = Memory                   !  Set number to memory
        cycle
      OF ?Zero TO ?Nine                   ! For a numeric key
        Digit = ACCEPTED() - ?Zero        !  The digit is the field number
         IF NewNumber                     !  For the first digit
          Number = Digit                  !   Set the number to the digit
          NewNumber = False               !   Turn NewNumber flag off
          Decimal = False                 !   Turn decimal point flag off
         ELSE                             !   For any other digit
          IF Decimal                      !    For a fractional digit
          IF DecimalFlg                      !!!
             Number=clip(number) &'.'& Digit !!!
             DecimalFlg = false              !!!
          ELSE                               !!!
            Number=clip(number) & digit      !!!
          END                                !!!
          ELSE                            !    For an integer digit
             DecimalFlg = true
             number=clip(number)& digit
          END                             !   End the IF
        END                               !   End the IF
        CYCLE                             !   Continue number entry
      OF ?Decimal                         ! For the decimal point key
        Decimal = True                    !  Turn decimal point flag on
        DecimalFlg=TRUE                   !!!Reset Flag
        IF NEWNUMBER = TRUE               !!!No need to press 0
           NUMBER = '0'                   !!!if new number
           NEWNUMBER = FALSE              !!!Reset Flag
        END                               !!!
        CYCLE                             !  Continue number entry
      OF ?Pi                              ! For the Pi key
        Number = 3.141592654              !  Set number to Pi
        NewNumber = TRUE                  !  Start new number
        CYCLE                             !  Continue
      OF ?Clear                           ! For the ClearEntry/Clear key
        IF NewNumber THEN                 !  completed number entry
          Operation = ?Equal              !   so Clear current calculation
        END                               !  End IF
        Number = 0                        !  Clear number
        NewNumber = 0                     !  Start new number
      END                                 ! End CASE
      IF Operation <> ?Equal              ! Complete outstanding operations
        IF ACCEPTED() = ?Percent          ! For the percent key
          Number = Number * Operand / 100 ! Calculate % value
          IF  (Operation <> ?Add ) |      ! Check not adding
          AND (Operation <> ?Subtract ) | !  or subtractiong percentage
          AND (Operation <> ?Multiply)  | !!! Added Multiply and Divide
          AND (Operation <> ?Divide)      !!! To the percentage
            Operation = ?Equal            !   Finished operation
          END                             !  End IF
        END                               ! End IF
        CASE Operation                    !  Jump to saved operation key
        OF ?Add                           ! For Add key
          Number += Operand               !   Add number to operand
        OF ?Subtract                      !  For Subtract key
          Number = Operand - Number       !   Subtract number from operand
        OF ?Multiply                      !  For Multiply key
          Number *= Operand               !   Multiply operand by number
        OF ?Divide                        !  For Divide key
          IF Number <> 0 THEN             !  Check for divide by zero
            Number = Operand / Number     !   Divide operand by number
          END                             !  End IF
        OF ?Power                         !  For Raise to a Power key
          Number = Operand ^ Number       !   Raise operand to number power
        END                               !  End CASE
        Operation = ?Equal                !  Operation done
      END                                 ! End IF
      CASE ACCEPTED()                     ! Jump to the accepted field
      OF ?Sign                            ! For the Change Sign key
        Number *= -1                      !  Multiply by -1
      OF ?Square                          ! For the Square key
        Number *= Number                  !  Multilpy by itself
      OF ?Root                            ! For the Square Root key
        Number = SQRT(Number)             !  Find the square root
      OF ?TenTimes                        ! For the 10X key
        Number *= 10                      !  Multiply by 10
      OF ?Reciprical                      ! For the Reciprical key
        IF Number <> 0 THEN               ! Check for divide by zero
          Number = 1/Number               !  Find the reciprical
        END                               ! End IF
      OF ?Log                             ! For the logarithm key
        Number = LOG10(Number)            !  Find the base 10 logarithm
      OF ?Ln                              ! For the natural logarithm key
        Number = LOGE(Number)             !  Find the natural logarithm
      OF ?Store                           ! For the Store memory key
        Memory = Number                   !  Set memory to number
      OF ?Accumulate                      ! For the Add to Memory key
        Memory += Number                  !  Add number to memory
      OF ?Add TO ?Power                   ! For two operand operation keys
        Operation = ACCEPTED()            !  Save the operator
        Operand = Number                  !  Save the first operand
      END                                 ! End CASE
!      SELECT(?Zero)                       ! Set focus to the Zero key
      NewNumber = TRUE                    ! ready for next number
      DecimalFlg = TRUE                   !!!Reset flag
    END                                   !End CASE
  END                                     !End ACCEPT
   CLOSE(Calculator)                      !Close the calculator window
   RNUMBER=NUMBER                         !!!
   RETURN(RNUMBER)                        !!!Return value

TINCALCULATORSTYLE3  FUNCTION (TITLEIN,NUMBERIN,FLATONOFF)  ! Declare Procedure

Number     REAL
Operand    REAL
Memory     REAL
Operation  REAL
NewNumber  BYTE
DecimalPoint    BYTE
Digit      BYTE


Calculator WINDOW('Calculator'),AT(80,7,101,128),IMM,ICON('TINCALC.ICO'),TILED,TIMER(100),SYSTEM,GRAY,RESIZE, |
         AUTO
       BUTTON('0'),AT(9,112,14,12),USE(?Zero),FONT('Arial',11,,FONT:bold),KEY(Keypad0)
       BUTTON('1'),AT(9,97,14,12),USE(?One),FONT('Arial',11,,FONT:bold),KEY(Keypad1)
       BUTTON('2'),AT(26,97,14,12),USE(?Two),FONT('Arial',11,,FONT:bold),KEY(Keypad2)
       BUTTON('3'),AT(43,97,14,12),USE(?Three),FONT('Arial',11,,FONT:bold),KEY(Keypad3)
       BUTTON('4'),AT(9,82,14,12),USE(?Four),FONT('Arial',11,,FONT:bold),KEY(Keypad4)
       BUTTON('5'),AT(26,82,14,12),USE(?Five),FONT('Arial',11,,FONT:bold),KEY(Keypad5)
       BUTTON('6'),AT(43,82,14,12),USE(?Six),FONT('Arial',11,,FONT:bold),KEY(Keypad6)
       BUTTON('7'),AT(9,68,14,12),USE(?Seven),FONT('Arial',11,,FONT:bold),KEY(KeyPad7)
       BUTTON('8'),AT(26,68,14,12),USE(?Eight),FONT('Arial',11,,FONT:bold),KEY(Keypad8)
       BUTTON('9'),AT(43,68,14,12),USE(?Nine),FONT('Arial',11,,FONT:bold),KEY(Keypad9)
       BUTTON('.'),AT(26,112,14,12),USE(?DecimalPoint),FONT('Arial',12,,FONT:bold),KEY(DecimalKey)
       BUTTON('CE'),AT(9,39,14,12),USE(?Clear),FONT('Arial',10,0FFH,FONT:bold),TIP('Clear')
       BUTTON('p'),AT(62,112,14,12),USE(?Pi),FONT('Symbol',12,,),TIP('Pi')
       BUTTON('+/-'),AT(62,97,14,12),USE(?Sign),FONT('Arial',10,,),TIP('Change Sign')
       BUTTON('x<178>'),AT(43,53,14,12),USE(?Square),FONT('Arial',10,,),TIP('Square')
       BUTTON(''),AT(26,53,14,12),USE(?Root),FONT('Symbol',12,,),TIP('Square Root')
       BUTTON('1/x'),AT(62,68,14,12),USE(?Reciprical),FONT('Arial',10,,),TIP('Reciprocal')
       BUTTON('10X'),AT(9,53,14,12),USE(?TenTimes),FONT('Arial',10,,),TIP('Times 10')
       BUTTON('%'),AT(78,54,14,12),USE(?Percent),FONT('Arial',12,,),TIP('Percent')
       BUTTON(' lg'),AT(26,39,14,12),USE(?Log),FONT('Arial',11,,)
       BUTTON(' ln'),AT(62,82,14,12),USE(?Ln),FONT('Arial',11,,),TIP('Ln')
       BUTTON('MR'),AT(43,39,14,12),USE(?Recall),FONT('Arial',10,,)
       BUTTON(' M'),AT(62,39,14,12),USE(?Store),FONT('Arial',10,,)
       BUTTON(' M+'),AT(78,39,14,12),USE(?Accumulate),FONT('Arial',10,,),TIP('Add To Memmory')
       BUTTON('+'),AT(78,112,14,12),USE(?Add),FONT('Arial',12,,),TIP('Add'),KEY(PlusKey)
       BUTTON('-'),AT(78,68,14,12),USE(?Subtract),FONT('Arial',12,,),TIP('Subtract'),KEY(MinusKey)
       BOX,AT(6,35,89,92),USE(?Box1),ROUND,COLOR(00H),FILL(0808040H)
       BUTTON('x'),AT(78,97,14,12),USE(?Multiply),FONT('Arial',12,,),TIP('Multiply'),KEY(AstKey)
       BUTTON('/'),AT(78,82,14,12),USE(?Divide),FONT('Arial',12,,),TIP('Divide'),KEY(SlashKey)
       BUTTON('Exp'),AT(62,53,14,12),USE(?Power),FONT('Arial',8,,),TIP('Power')
       BUTTON('='),AT(43,112,14,12),USE(?Equal),FONT('Arial',12,,),KEY(EnterKey)
       ENTRY(@s15),AT(2,6,97,13),USE(Number),RIGHT(3),FONT('Arial',14,,),INS
     END

  CODE
  OPEN(Calculator)
  
  IF ~OMITTED(1) AND TITLEIN THEN
    CALCULATOR{PROP:TEXT} = CLIP(TITLEIN)
  END

  IF ~OMITTED(2) AND NUMBERIN THEN
    NUMBER = NUMBERIN
    NEWNUMBER = FALSE
  ELSE
    NewNumber = True                      !Start with a new number
  END

  LOOP X#=FIRSTFIELD() TO LASTFIELD()
    IF CALCULATOR$X#{Prop:Type} = CREATE:BUTTON AND FLATONOFF THEN
      CALCULATOR$X#{Prop:Flat}  = FLATONOFF
      IF CALCULATOR$X#{Prop:Icon} = '' THEN
        CALCULATOR$X#{Prop:Icon} = 'Blank.ico'
      END
    END
  END

  DecimalPoint = False
  Operation = ?Equal

!-----------------------------------------------------------------------------

 ACCEPT
 Display
 if NewNumber
 decit#=0
 end
 IF ACCEPTED()

    CASE ACCEPTED()
      OF ?Zero TO ?nine
        Digit = ACCEPTED() - ?Zero
        IF NewNumber
        if decimalPoint
        number = '.' & digit
        NewNumber = False
        Decit# = 1
        ELSE
         Number = Digit
          NewNumber = False
          DecimalPoint = False
          END
        ELSE
           IF DecimalPoint
           IF Decit# = 0
           Number = Clip(Number) &'.' & Digit
           Decit# = 1
           Else
           number = clip(number) & digit
           end
           else
           number = number * 10 + Digit
           END
        END
        CYCLE
      OF ?DecimalPoint
        DecimalPoint = True
        CYCLE
      OF ?Pi
        Number = 3.141592654
        NewNumber = TRUE
        DecimalPoint = False
        CYCLE
      OF ?Clear
        IF NewNumber THEN
          Operation = ?Equal
        END
        Number = 0
        NewNumber = 0
        DecimalPoint = False
      END

      IF Operation <> ?Equal
        IF ACCEPTED() = ?Percent
          Number = Number * Operand / 100
          IF  (Operation <> ?Add )     |
          AND (Operation <> ?Subtract )
            Operation = ?Equal
          END
        END
        CASE Operation
        OF ?Add
          Number += Operand
        OF ?Subtract
          Number = Operand - Number
        OF ?Multiply
          Number *= Operand
        OF ?Divide
          IF Number <> 0 THEN
            Number = Operand / Number
          END
        OF ?Power
          Number = Operand ^ Number
        END
        Operation = ?Equal
      END
      CASE ACCEPTED()
      OF ?Sign
        Number *= -1
      OF ?Square
        Number *= Number
      OF ?Root
        Number = SQRT(Number)
      OF ?TenTimes
        Number *= 10
      OF ?Reciprical
        IF Number <> 0 THEN
          Number = 1/Number
        END
      OF ?Log
        Number = LOG10(Number)
      OF ?Ln
        Number = LOGE(Number)

      OF ?Recall
        Number = Memory
      OF ?Store
        Memory = Number
      OF ?Accumulate
        Memory += Number

      OF ?Add TO ?Power
        Operation = ACCEPTED()
        Operand = Number
      END
!      SELECT(?Zero)
      NewNumber = TRUE
      DecimalPoint = False

    END                       !End CASE

  END                         !End ACCEPT

  CLOSE(Calculator)           !Close calculater window
  RETURN(NUMBER)
