!--------------------------------------------------------------------------
! (c) 1996 thru 2003 by
! Tinman Development Corporation
!                And
! Reichenberger Development Incorporated
! All Rights Reserved World Wide
! ISBN: 0-933735-17-0
! 
!--------------------------------------------------------------------------
TINCALENDARSTYLE1 FUNCTION (Passeddate)
! Extension Function: Original  Fingertips 1996-1997, Tim Down (100705.1546@compuserve.com)
! DESCRIPTION: Displays popup calendar window to allow user to scroll through the months
!              and return a date by clicking on it.
!
! USAGE:       Calendar(LONG)    If starting date is omitted, defaults to current date.
! RETURNS:     LONG
!________________________________________________________________________________________________
!|                                 REVISIONS
!|                                 =========
!| DATE                 CHANGE                                
!|_______________________________________________________________________________________________
!| 07/10/96       1st Day of week changed to Sunday.          
!|
!| 22/11/96       Bevel to represent current day number       
!|                is carried from month to month when
!|                scrolling the months/years.
!Define Variables
MonthNumber    SHORT
YearNumber     SHORT
!Define Window
window WINDOW('Caption'),AT(,,121,80),FONT('MS Sans Serif',8,,FONT:regular),CENTER,ALRT(UpKey),ALRT(DownKey), |
         ALRT(PgUpKey),ALRT(PgDnKey),ALRT(EscKey),ALRT(RightKey),ALRT(LeftKey),ALRT(MouseRight),GRAY, |
         DOUBLE
       STRING('Month'),AT(95,18),FONT(,,080H,),USE(?StringMonth),TRN,CENTER
       STRING('Year'),AT(98,51),FONT(,,080H,),USE(?StringYear),TRN,CENTER
       STRING('Su'),AT(2,1,10,10),FONT(,,0FFH,),USE(?StringMo),CENTER
       STRING('Mo'),AT(15,1,10,10),FONT(,,0800000H,),USE(?StringTu),CENTER
       STRING('Tu'),AT(27,1,10,10),FONT(,,0800000H,),USE(?StringWe),CENTER
       STRING('We'),AT(39,1,12,10),FONT(,,0800000H,),USE(?StringTh),CENTER
       STRING('Th'),AT(51,1,10,10),FONT(,,0800000H,),USE(?StringFr),CENTER
       STRING('Fr'),AT(63,1,10,10),FONT(,,0800000H,),USE(?StringSa),CENTER
       STRING('Sa'),AT(74,1,10,10),FONT(,,0FFH,),USE(?StringSu),CENTER
       SPIN(@n-6),AT(93,27,24,12),USE(MonthNumber),IMM,HSCROLL,STEP(1)
       SPIN(@n-6),AT(93,60,24,12),USE(YearNumber),IMM,HSCROLL,STEP(1)
       PANEL,AT(0,0,,12),USE(?Panel1),FULL,BEVEL(0,0,09H)
       PANEL,AT(89,48,32,29),USE(?Panel2),BEVEL(-1)
       PANEL,AT(89,15,32,29),USE(?Panel3),BEVEL(-1)
       REGION,AT(3,15,10,10),USE(?Region1),IMM
       REGION,AT(15,15,10,10),USE(?Region2),IMM
       REGION,AT(27,15,10,10),USE(?Region3),IMM
       REGION,AT(39,15,10,10),USE(?Region4),IMM
       REGION,AT(51,15,10,10),USE(?Region5),IMM
       REGION,AT(63,15,10,10),USE(?Region6),IMM
       REGION,AT(75,15,10,10),USE(?Region7),IMM
       REGION,AT(3,26,10,10),USE(?Region8),IMM
       REGION,AT(15,26,10,10),USE(?Region9),IMM
       REGION,AT(27,26,10,10),USE(?Region10),IMM
       REGION,AT(39,26,10,10),USE(?Region11),IMM
       REGION,AT(51,26,10,10),USE(?Region12),IMM
       REGION,AT(63,26,10,10),USE(?Region13),IMM
       REGION,AT(75,26,10,10),USE(?Region14),IMM
       REGION,AT(3,37,10,10),USE(?Region15),IMM
       REGION,AT(15,37,10,10),USE(?Region16),IMM
       REGION,AT(27,37,10,10),USE(?Region17),IMM
       REGION,AT(39,37,10,10),USE(?Region18),IMM
       REGION,AT(51,37,10,10),USE(?Region19),IMM
       REGION,AT(63,37,10,10),USE(?Region20),IMM
       REGION,AT(75,37,10,10),USE(?Region21),IMM
       REGION,AT(3,48,10,10),USE(?Region22),IMM
       REGION,AT(15,48,10,10),USE(?Region23),IMM
       REGION,AT(27,48,10,10),USE(?Region24),IMM
       REGION,AT(39,48,10,10),USE(?Region25),IMM
       REGION,AT(51,48,10,10),USE(?Region26),IMM
       REGION,AT(63,48,10,10),USE(?Region27),IMM
       REGION,AT(75,48,10,10),USE(?Region28),IMM
       REGION,AT(3,59,10,10),USE(?Region29),IMM
       REGION,AT(15,59,10,10),USE(?Region30),IMM
       REGION,AT(27,59,10,10),USE(?Region31),IMM
       REGION,AT(39,59,10,10),USE(?Region32),IMM
       REGION,AT(51,59,10,10),USE(?Region33),IMM
       REGION,AT(63,59,10,10),USE(?Region34),IMM
       REGION,AT(75,59,10,10),USE(?Region35),IMM
       REGION,AT(3,70,10,10),USE(?Region36),IMM
       REGION,AT(15,70,10,10),USE(?Region37),IMM
       STRING(''),AT(1,16,10,10),USE(?String1),TRN,RIGHT
       STRING(''),AT(13,16,10,10),USE(?String2),TRN,RIGHT
       STRING(''),AT(25,16,10,10),USE(?String3),TRN,RIGHT
       STRING(''),AT(37,16,10,10),USE(?String4),TRN,RIGHT
       STRING(''),AT(49,16,10,10),USE(?String5),TRN,RIGHT
       STRING(''),AT(61,16,10,10),USE(?String6),TRN,RIGHT
       STRING(''),AT(73,16,10,10),USE(?String7),TRN,RIGHT
       STRING(''),AT(1,27,10,10),USE(?String8),TRN,RIGHT
       STRING(''),AT(13,27,10,10),USE(?String9),TRN,RIGHT
       STRING(''),AT(25,27,10,10),USE(?String10),TRN,RIGHT
       STRING(''),AT(37,27,10,10),USE(?String11),TRN,RIGHT
       STRING(''),AT(49,27,10,10),USE(?String12),TRN,RIGHT
       STRING(''),AT(61,27,10,10),USE(?String13),TRN,RIGHT
       STRING(''),AT(73,27,10,10),USE(?String14),TRN,RIGHT
       STRING(''),AT(1,38,10,10),USE(?String15),TRN,RIGHT
       STRING(''),AT(13,38,10,10),USE(?String16),TRN,RIGHT
       STRING(''),AT(25,38,10,10),USE(?String17),TRN,RIGHT
       STRING(''),AT(37,38,10,10),USE(?String18),TRN,RIGHT
       STRING(''),AT(49,38,10,10),USE(?String19),TRN,RIGHT
       STRING(''),AT(61,38,10,10),USE(?String20),TRN,RIGHT
       STRING(''),AT(73,38,10,10),USE(?String21),TRN,RIGHT
       STRING(''),AT(1,49,10,10),USE(?String22),TRN,RIGHT
       STRING(''),AT(13,49,10,10),USE(?String23),TRN,RIGHT
       STRING(''),AT(25,49,10,10),USE(?String24),TRN,RIGHT
       STRING(''),AT(37,49,10,10),USE(?String25),TRN,RIGHT
       STRING(''),AT(49,49,10,10),USE(?String26),TRN,RIGHT
       STRING(''),AT(61,49,10,10),USE(?String27),TRN,RIGHT
       STRING(''),AT(73,49,10,10),USE(?String28),TRN,RIGHT
       STRING(''),AT(1,60,10,10),USE(?String29),TRN,RIGHT
       STRING(''),AT(13,60,10,10),USE(?String30),TRN,RIGHT
       STRING(''),AT(25,60,10,10),USE(?String31),TRN,RIGHT
       STRING(''),AT(37,60,10,10),USE(?String32),TRN,RIGHT
       STRING(''),AT(49,60,10,10),USE(?String33),TRN,RIGHT
       STRING(''),AT(61,60,10,10),USE(?String34),TRN,RIGHT
       STRING(''),AT(73,60,10,10),USE(?String35),TRN,RIGHT
       STRING(''),AT(1,71,10,10),USE(?String36),TRN,RIGHT
       STRING(''),AT(13,71,10,10),USE(?String37),TRN,RIGHT
     END
  CODE                                            ! Begin processed code
!Open Calendar Window
  PUSHBIND
  OPEN(Window)
  !Set up initial display
  IF PassedDate = ''         !If no date was passed default to current date
     PassedDate=Today()
  END
  MonthNumber = MONTH(PassedDate)
  YearNumber = YEAR(PassedDate)
  DO SetWindowTitle
  DO AssignAllStrings
  DO HighlightPassedDate
  ACCEPT
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
         OF UpKey OROF LeftKey
            MonthNumber -=1
         OF DownKey OROF RightKey
            MonthNumber +=1
         OF PgUpKey
            YearNumber -= 1
         OF PgDnKey
            YearNumber += 1
         OF EscKey                   !Close, returning passed date or default current date
            POPBIND
            RETURN(PassedDate)
         OF MouseRight               !Close, returning passed date or default current date
            POPBIND
            RETURN(PassedDate)
      END!CASE KEYCODE
      IF    MonthNumber > 12
            MonthNumber = 1
            YearNumber +=1
      ELSIF MonthNumber < 1
            MonthNumber = 12
            YearNumber -=1
      END!IF
      DO CheckRange
      DO SetWindowTitle
      DO ClearHighlight
      DO AssignAllStrings
      DO HighlightPassedDate
    END!CASE EVENT
    CASE FIELD()
    OF ?MonthNumber
      CASE EVENT()
      OF EVENT:NewSelection
        !Change year if month goes past 12 or before 1
        IF MonthNumber > 12
              MonthNumber = 1
              YearNumber +=1
        ELSIF MonthNumber < 1
              MonthNumber = 12
              YearNumber -=1
        END
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?YearNumber
      CASE EVENT()
      OF EVENT:NewSelection
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Region1
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String1{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String1{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
         END
      END
    OF ?Region2
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String2{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String2{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region3
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String3{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String3{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region4
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String4{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String4{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region5
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String5{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String5{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region6
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String6{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String6{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region7
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String7{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region8
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String8{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region9
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String9{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region10
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String10{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region11
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String11{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region12
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String12{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region13
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String13{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region14
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String14{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region15
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String15{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region16
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String16{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region17
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String17{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region18
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String18{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region19
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String19{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region20
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String20{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region21
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String21{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region22
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String22{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region23
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String23{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region24
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String24{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region25
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String25{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region26
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String26{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region27
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String27{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region28
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String28{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region29
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String29{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String29{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region30
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String30{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String30{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region31
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String31{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String31{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region32
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String32{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String32{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region33
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String33{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String33{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region34
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String34{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String34{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region35
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String35{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String35{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region36
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String36{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String36{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region37
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String37{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String37{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    END!CASE FIELD
  END!ACCEPT LOOP
!------------------------------------------------------------------------------------------------
SetWindowTitle ROUTINE
!|Set up the window title
    CASE MonthNumber
         OF  1
             Window{PROP:TEXT}='January ' &YearNumber
         OF  2
             Window{PROP:TEXT}='February ' &YearNumber
         OF  3
             Window{PROP:TEXT}='March ' &YearNumber
         OF  4
             Window{PROP:TEXT}='April ' &YearNumber
         OF  5
             Window{PROP:TEXT}='May ' &YearNumber
         OF  6
             Window{PROP:TEXT}='June ' &YearNumber
         OF  7
             Window{PROP:TEXT}='July ' &YearNumber
         OF  8
             Window{PROP:TEXT}='August ' &YearNumber
         OF  9
             Window{PROP:TEXT}='September ' &YearNumber
         OF  10
             Window{PROP:TEXT}='October ' &YearNumber
         OF  11
             Window{PROP:TEXT}='November ' &YearNumber
         OF  12
             Window{PROP:TEXT}='December ' &YearNumber
    END!CASE
!|----------------------------------------------------------------------------------------------
AssignAllStrings ROUTINE
!|Redraws the calendar for the current month
!|
   !How many days are there in this month?
   CASE MonthNumber
     OF     9                           !Short months
     OROF   4
     OROF   6
     OROF   11
            MaxDays#=30                 
     OF     2                           !If the month is February
            IF YearNumber % 4 = 0       !If a leap year
               MaxDays# = 29            
            ELSE
               MaxDays# = 28
            END!IF
     ELSE   MaxDays# = 31               !Standard months
   END!CASE
   !Find what day the first of this month falls on.
   CASE DEFORMAT(('1/' &MonthNumber &'/' &YearNumber),@D6) % 7
      OF 0                              !Month starts on a Sunday
         ?String1{PROP:TEXT} = '1'      
         ?String2{PROP:TEXT} = '2'
         ?String3{PROP:TEXT} = '3'
         ?String4{PROP:TEXT} = '4'
         ?String5{PROP:TEXT} = '5'
         ?String6{PROP:TEXT} = '6'
         ?String7{PROP:TEXT} = '7'
      OF 1                              !Month starts on a Monday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = '1'
         ?String3{PROP:TEXT} = '2'
         ?String4{PROP:TEXT} = '3'
         ?String5{PROP:TEXT} = '4'
         ?String6{PROP:TEXT} = '5'
         ?String7{PROP:TEXT} = '6'
      OF 2                              !Month starts on a Tuesday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = '1'
         ?String4{PROP:TEXT} = '2'
         ?String5{PROP:TEXT} = '3'
         ?String6{PROP:TEXT} = '4'
         ?String7{PROP:TEXT} = '5'
      OF 3                              !Month starts on a Wednesday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = '1'
         ?String5{PROP:TEXT} = '2'
         ?String6{PROP:TEXT} = '3'
         ?String7{PROP:TEXT} = '4'
      OF 4                              !Month starts on a Thursday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = '1'
         ?String6{PROP:TEXT} = '2'
         ?String7{PROP:TEXT} = '3'
      OF 5                              !Month starts on a Friday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = ''
         ?String6{PROP:TEXT} = '1'
         ?String7{PROP:TEXT} = '2'
      OF 6                              !Month starts on a Saturday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = ''
         ?String6{PROP:TEXT} = ''
         ?String7{PROP:TEXT} = '1'
   END
  !Format the strings for the rest of the current month.
  !From day 8 to 28 just add 1 to the previous string, then
  !start checking for potential last day of month from string 29 onwards
  ?String8{PROP:TEXT} = DEFORMAT(?String7{PROP:TEXT},@n2) + 1
  ?String9{PROP:TEXT} = DEFORMAT(?String8{PROP:TEXT},@n2) + 1
  ?String10{PROP:TEXT} = DEFORMAT(?String9{PROP:TEXT},@n2) + 1
  ?String11{PROP:TEXT} = DEFORMAT(?String10{PROP:TEXT},@n2) + 1
  ?String12{PROP:TEXT} = DEFORMAT(?String11{PROP:TEXT},@n2) + 1
  ?String13{PROP:TEXT} = DEFORMAT(?String12{PROP:TEXT},@n2) + 1
  ?String14{PROP:TEXT} = DEFORMAT(?String13{PROP:TEXT},@n2) + 1
  ?String15{PROP:TEXT} = DEFORMAT(?String14{PROP:TEXT},@n2) + 1
  ?String16{PROP:TEXT} = DEFORMAT(?String15{PROP:TEXT},@n2) + 1
  ?String17{PROP:TEXT} = DEFORMAT(?String16{PROP:TEXT},@n2) + 1
  ?String18{PROP:TEXT} = DEFORMAT(?String17{PROP:TEXT},@n2) + 1
  ?String19{PROP:TEXT} = DEFORMAT(?String18{PROP:TEXT},@n2) + 1
  ?String20{PROP:TEXT} = DEFORMAT(?String19{PROP:TEXT},@n2) + 1
  ?String21{PROP:TEXT} = DEFORMAT(?String20{PROP:TEXT},@n2) + 1
  ?String22{PROP:TEXT} = DEFORMAT(?String21{PROP:TEXT},@n2) + 1
  ?String23{PROP:TEXT} = DEFORMAT(?String22{PROP:TEXT},@n2) + 1
  ?String24{PROP:TEXT} = DEFORMAT(?String23{PROP:TEXT},@n2) + 1
  ?String25{PROP:TEXT} = DEFORMAT(?String24{PROP:TEXT},@n2) + 1
  ?String26{PROP:TEXT} = DEFORMAT(?String25{PROP:TEXT},@n2) + 1
  ?String27{PROP:TEXT} = DEFORMAT(?String26{PROP:TEXT},@n2) + 1
  ?String28{PROP:TEXT} = DEFORMAT(?String27{PROP:TEXT},@n2) + 1
  IF (DEFORMAT(?String28{PROP:TEXT},@n2) + 1) NOT > Maxdays#
     ?String29{PROP:TEXT} = DEFORMAT(?String28{PROP:TEXT},@n2) + 1
  ELSE
     ?String29{PROP:TEXT} = ''
  END
  IF ?String29{PROP:TEXT} <> '' AND (DEFORMAT(?String29{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String30{PROP:TEXT} = DEFORMAT(?String29{PROP:TEXT},@n2) + 1
  ELSE
     ?String30{PROP:TEXT} = ''
  END
  IF ?String30{PROP:TEXT} <> '' AND (DEFORMAT(?String30{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String31{PROP:TEXT} = DEFORMAT(?String30{PROP:TEXT},@n2) + 1
  ELSE
     ?String31{PROP:TEXT} = ''
  END
  IF ?String31{PROP:TEXT} <> '' AND (DEFORMAT(?String31{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String32{PROP:TEXT} = DEFORMAT(?String31{PROP:TEXT},@n2) + 1
  ELSE
     ?String32{PROP:TEXT} = ''
  END
  IF ?String32{PROP:TEXT} <> '' AND (DEFORMAT(?String32{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String33{PROP:TEXT} = DEFORMAT(?String32{PROP:TEXT},@n2) + 1
  ELSE
     ?String33{PROP:TEXT} = ''
  END
  IF ?String33{PROP:TEXT} <> '' AND (DEFORMAT(?String33{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String34{PROP:TEXT} = DEFORMAT(?String33{PROP:TEXT},@n2) + 1
  ELSE
     ?String34{PROP:TEXT} = ''
  END
  IF ?String34{PROP:TEXT} <> '' AND (DEFORMAT(?String34{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String35{PROP:TEXT} = DEFORMAT(?String34{PROP:TEXT},@n2) + 1
  ELSE
     ?String35{PROP:TEXT} = ''
  END
  IF ?String35{PROP:TEXT} <> '' AND (DEFORMAT(?String35{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String36{PROP:TEXT} = DEFORMAT(?String35{PROP:TEXT},@n2) + 1
  ELSE
     ?String36{PROP:TEXT} = ''
  END
  IF ?String36{PROP:TEXT} <> '' AND (DEFORMAT(?String36{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String37{PROP:TEXT} = DEFORMAT(?String36{PROP:TEXT},@n2) + 1
  ELSE
     ?String37{PROP:TEXT} = ''
  END
!|-------------------------------------------------------------------------------------------
HighlightPassedDate ROUTINE
!| Bevel the region representing the passed date
!|
   IF DAY(PassedDate) > MaxDays# THEN EXIT      !Added this line so if day is
   END                                          !beyond max in new month = no bevel
   CASE DAY(PassedDate)
   OF ?String1{PROP:TEXT}
      ?Region1{PROP:BEVEL} = -1
   OF ?String2{PROP:TEXT}
      ?Region2{PROP:BEVEL} = -1
   OF ?String3{PROP:TEXT}
      ?Region3{PROP:BEVEL} = -1
   OF ?String4{PROP:TEXT}
      ?Region4{PROP:BEVEL} = -1
   OF ?String5{PROP:TEXT}
      ?Region5{PROP:BEVEL} = -1
   OF ?String6{PROP:TEXT}
      ?Region6{PROP:BEVEL} = -1
   OF ?String7{PROP:TEXT}
      ?Region7{PROP:BEVEL} = -1
   OF ?String8{PROP:TEXT}
      ?Region8{PROP:BEVEL} = -1
   OF ?String9{PROP:TEXT}
      ?Region9{PROP:BEVEL} = -1
   OF ?String10{PROP:TEXT}
      ?Region10{PROP:BEVEL} = -1
   OF ?String11{PROP:TEXT}
      ?Region11{PROP:BEVEL} = -1
   OF ?String12{PROP:TEXT}
      ?Region12{PROP:BEVEL} = -1
   OF ?String13{PROP:TEXT}
      ?Region13{PROP:BEVEL} = -1
   OF ?String14{PROP:TEXT}
      ?Region14{PROP:BEVEL} = -1
   OF ?String15{PROP:TEXT}
      ?Region15{PROP:BEVEL} = -1
   OF ?String16{PROP:TEXT}
      ?Region16{PROP:BEVEL} = -1
   OF ?String17{PROP:TEXT}
      ?Region17{PROP:BEVEL} = -1
   OF ?String18{PROP:TEXT}
      ?Region18{PROP:BEVEL} = -1
   OF ?String19{PROP:TEXT}
      ?Region19{PROP:BEVEL} = -1
   OF ?String20{PROP:TEXT}
      ?Region20{PROP:BEVEL} = -1
   OF ?String21{PROP:TEXT}
      ?Region21{PROP:BEVEL} = -1
   OF ?String22{PROP:TEXT}
      ?Region22{PROP:BEVEL} = -1
   OF ?String23{PROP:TEXT}
      ?Region23{PROP:BEVEL} = -1
   OF ?String24{PROP:TEXT}
      ?Region24{PROP:BEVEL} = -1
   OF ?String25{PROP:TEXT}
      ?Region25{PROP:BEVEL} = -1
   OF ?String26{PROP:TEXT}
      ?Region26{PROP:BEVEL} = -1
   OF ?String27{PROP:TEXT}
      ?Region27{PROP:BEVEL} = -1
   OF ?String28{PROP:TEXT}
      ?Region28{PROP:BEVEL} = -1
   OF ?String29{PROP:TEXT}
      ?Region29{PROP:BEVEL} = -1
   OF ?String30{PROP:TEXT}
      ?Region30{PROP:BEVEL} = -1
   OF ?String31{PROP:TEXT}
      ?Region31{PROP:BEVEL} = -1
   OF ?String32{PROP:TEXT}
      ?Region32{PROP:BEVEL} = -1
   OF ?String33{PROP:TEXT}
      ?Region33{PROP:BEVEL} = -1
   OF ?String34{PROP:TEXT}
      ?Region34{PROP:BEVEL} = -1
   OF ?String35{PROP:TEXT}
      ?Region35{PROP:BEVEL} = -1
   OF ?String36{PROP:TEXT}
      ?Region36{PROP:BEVEL} = -1
   OF ?String37{PROP:TEXT}
      ?Region37{PROP:BEVEL} = -1
   END!CASE
!|--------------------------------------------------------------------------------------------
ClearHighlight ROUTINE
!| Clear any Bevels
!|
   IF ?Region1{PROP:BEVEL} <> 0 THEN ?Region1{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region2{PROP:BEVEL} <> 0 THEN ?Region2{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region3{PROP:BEVEL} <> 0 THEN ?Region3{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region4{PROP:BEVEL} <> 0 THEN ?Region4{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region5{PROP:BEVEL} <> 0 THEN ?Region5{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region6{PROP:BEVEL} <> 0 THEN ?Region6{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region7{PROP:BEVEL} <> 0 THEN ?Region7{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region8{PROP:BEVEL} <> 0 THEN ?Region8{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region9{PROP:BEVEL} <> 0 THEN ?Region9{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region10{PROP:BEVEL} <> 0 THEN ?Region10{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region11{PROP:BEVEL} <> 0 THEN ?Region11{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region12{PROP:BEVEL} <> 0 THEN ?Region12{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region13{PROP:BEVEL} <> 0 THEN ?Region13{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region14{PROP:BEVEL} <> 0 THEN ?Region14{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region15{PROP:BEVEL} <> 0 THEN ?Region15{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region16{PROP:BEVEL} <> 0 THEN ?Region16{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region17{PROP:BEVEL} <> 0 THEN ?Region17{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region18{PROP:BEVEL} <> 0 THEN ?Region18{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region19{PROP:BEVEL} <> 0 THEN ?Region19{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region20{PROP:BEVEL} <> 0 THEN ?Region20{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region21{PROP:BEVEL} <> 0 THEN ?Region21{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region22{PROP:BEVEL} <> 0 THEN ?Region22{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region23{PROP:BEVEL} <> 0 THEN ?Region23{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region24{PROP:BEVEL} <> 0 THEN ?Region24{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region25{PROP:BEVEL} <> 0 THEN ?Region25{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region26{PROP:BEVEL} <> 0 THEN ?Region26{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region27{PROP:BEVEL} <> 0 THEN ?Region27{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region28{PROP:BEVEL} <> 0 THEN ?Region28{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region29{PROP:BEVEL} <> 0 THEN ?Region29{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region30{PROP:BEVEL} <> 0 THEN ?Region30{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region31{PROP:BEVEL} <> 0 THEN ?Region31{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region32{PROP:BEVEL} <> 0 THEN ?Region32{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region33{PROP:BEVEL} <> 0 THEN ?Region33{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region34{PROP:BEVEL} <> 0 THEN ?Region34{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region35{PROP:BEVEL} <> 0 THEN ?Region35{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region36{PROP:BEVEL} <> 0 THEN ?Region36{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region37{PROP:BEVEL} <> 0 THEN ?Region37{PROP:BEVEL} = 0
      EXIT
   END
!|---------------------------------------------------------======------------------
CheckRange ROUTINE
!|Gives error message if year is out of range
!|
  IF    YearNumber < 1801
        YearNumber = 1801
        MESSAGE('You cannot use the calendar for<13,10>'&|
        'dates before the year 1801', |
        'Date Out Of Range', Icon:Asterisk, |
        Button:Ok, Button:Ok, 0)
  ELSIF YearNumber > 2099
        YearNumber = 2099
        MESSAGE('You cannot use the calendar for<13,10>'&|
        'dates after the year 2099', |
        'Date Out Of Range', Icon:Asterisk, |
        Button:Ok, Button:Ok, 0)
  END
!|--------------------------------------------------------------------------------
!|--------------------------------------------------------------------------------
TINCALENDARSTYLE2    FUNCTION (STARTTITLE,STARTDATE) ! Declare Procedure
WorkingDate LONG
WorkMonth   SHORT
Ymouse      SHORT
Xmouse      SHORT
Xaxis       SHORT
DGpointer   SHORT
DateGroup   Group,Pre(DG)
X             SHORT,DIM(42)
Y             SHORT,DIM(42)
ActualDate    LONG,DIM(42)
            END

MonthText   String(111)

Cal2 WINDOW('Calendar'),AT(,,95,122),CENTER,ALRT(PgUpKey),ALRT(CtrlPgUp),ALRT(PgDnKey),ALRT(CtrlPgDn), |
         ALRT(HomeKey),ALRT(LeftKey),ALRT(UpKey),ALRT(RightKey),ALRT(DownKey),ALRT(EnterKey),ALRT(EscKey), |
         GRAY,DOUBLE
       STRING(@s20),AT(7,29,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[1:20]),TRN
       STRING(@s20),AT(7,41,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[22:41]),TRN
       STRING(@s20),AT(7,53,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[43:62]),TRN
       STRING(@s20),AT(7,65,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[64:83]),TRN
       STRING(@s20),AT(7,77,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[85:104]),TRN
       STRING(@s20),AT(7,89,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[106:111]),TRN
       STRING('Sun'),AT(5,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       STRING('Mon'),AT(17,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Tue'),AT(29,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Wed'),AT(41,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Thr'),AT(54,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Fri'),AT(65,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Sat'),AT(77,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       BOX,AT(5,27,84,72),COLOR(0808080H)
       LINE,AT(17,27,0,72),COLOR(0808080H)
       LINE,AT(29,27,0,72),COLOR(0808080H)
       LINE,AT(41,27,0,72),COLOR(0808080H)
       LINE,AT(53,27,0,72),COLOR(0808080H)
       LINE,AT(65,27,0,72),COLOR(0808080H)
       LINE,AT(77,27,0,72),COLOR(0808080H)
       LINE,AT(5,39,84,0),COLOR(0808080H)
       LINE,AT(5,51,84,0),COLOR(0808080H)
       LINE,AT(5,63,84,0),COLOR(0808080H)
       LINE,AT(5,75,84,0),COLOR(0808080H)
       LINE,AT(5,87,84,0),COLOR(0808080H)
       ENTRY(@s20),AT(24,5,65,10),FONT('Arial',8,,FONT:regular),USE(?ForLooksOnly),SKIP,DISABLE,CENTER
       REGION,AT(5,27,84,72),USE(?Region1),IMM
       BUTTON('Today !'),AT(28,105,39,11),FONT('Arial',8,,FONT:bold),USE(?GoToday)
       BUTTON,AT(5,105,14,11),FONT('Arial',8,,FONT:bold),USE(?MonthMinus),ICON(ICON:VCRback)
       BUTTON,AT(76,105,14,11),FONT('Arial',8,,FONT:bold),USE(?MonthPlus),ICON(ICON:VCRplay)
       BUTTON,AT(5,5,16,10),FONT('Arial',8,,FONT:bold),USE(?ExitNoDate),ICON(ICON:Cross)
       STRING(@d4),AT(26,7,61,7),FONT('Arial',8,,FONT:bold),USE(WorkingDate),TRN,CENTER
       BOX,AT(5,27,12,12),USE(?ActiveDay),COLOR(0FF0000H),FILL(0FFFFFFH)
     END
  CODE                                            ! Begin processed code
  ROW# = 27
  COL# = 5
  Ymouse = 0
  Xmouse = 0

  IF OMITTED(2) OR ~StartDate THEN
    WorkingDate = TODAY()
  ELSE
    WorkingDate = StartDate
  END

  WorkMonth = Month(WorkingDate)

  OPEN(CAL2)

  IF ~OMITTED(1) AND STARTTITLE THEN CAL2{PROP:TEXT} = CLIP(STARTTITLE).

  DO PreLoad
  Select(?GoToday)
  ACCEPT

    DISPLAY()

    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:GainFocus
    OF EVENT:AlertKey
    CASE Keycode()
      OF RightKey
        DO NextDay
      OF LeftKey
        DO PrevDay
      OF DownKey
        DO NextWeek
      OF UpKey
        DO PrevWeek
      OF PgDnKey
        DO NextMonth
      OF PgUpKey
        DO PrevMonth
      OF HomeKey
        DO Set2Start
      OF CtrlPgDn
        DO NextYear
      OF CtrlPgUp
        DO PrevYear
      OF EnterKey
        DO EndProcedure
      OF EscKey
        WorkingDate = 0
        DO EndProcedure
      END
      Xmouse = 0
      Ymouse = 0
      Select(?GoToday)
      CYCLE
    END

    CASE FIELD()
    OF ?Region1
      IF EVENT() = EVENT:MouseUp
        IF MouseY()=Ymouse and MouseX()=Xmouse      !<== DOUBLE CLICK ON DATE, YES I KNOW... BUT IT _DOES_ WORK!
          DO EndProcedure
        END
        Ymouse = MouseY()
        Xmouse = MouseX()
        DO FindMouseQ
        IF ~FOUND#
          Xmouse = 0
          Ymouse = 0
        END
      END
    OF ?MonthPlus
      IF EVENT() = EVENT:Accepted
        DO NextMonth
        Xmouse = 0
        Ymouse = 0
      END
      Cycle
    OF ?MonthMinus
      IF EVENT() = EVENT:Accepted
        DO PrevMonth
        Xmouse = 0
        Ymouse = 0
      END
      Cycle
    OF ?ExitNoDate
      IF EVENT() = EVENT:Accepted
        WorkingDate = 0
        DO EndProcedure
      END
      Cycle
    OF ?GoToday
      IF EVENT() = EVENT:Accepted
        DO Set2Today
        Xmouse = 0
        Ymouse = 0
      END
    END
    Select(?GoToday)
    Cycle
  END
  DO EndProcedure

EndProcedure Routine
  POST(EVENT:CloseWindow)
  RETURN(WorkingDate)

NextDay Routine
  WorkingDate += 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# += 12
  IF COL# > 77
    COL# = 5
    ROW# += 12
  END
  Cal2$?ActiveDay{PROP:Xpos} = COL#
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevDay Routine
  WorkingDate -= 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# -= 12
  IF COL# < 5
    COL# = 77
    ROW# -= 12
  END
  Cal2$?ActiveDay{PROP:Xpos} = COL#
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextWeek Routine
  WorkingDate += 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# += 12
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevWeek Routine
  WorkingDate -= 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# -= 12
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextMonth Routine
  WorkingDate=Date(WorkMonth+1,day(WorkingDate),year(WorkingDate))      !            But it works OK when month = 13
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevMonth Routine
  IF WorkMonth=1                                                        !Workaround: CW(1001) has a problem with its
    WorkingDate=Date(12,day(WorkingDate),year(WorkingDate)-1)           !            DATE() function when month = 0
  ELSE
    WorkingDate=Date(WorkMonth-1,day(WorkingDate),year(WorkingDate))
  END
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

NextYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)+1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)-1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Today Routine
  WorkingDate = TODAY()
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Start Routine
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

LoadMonth routine
  MonthText=''
  CLEAR(DG:ActualDate[])
  XDate#=date(month(WorkingDate),1,year(WorkingDate))
  Kill#=day(date(month(WorkingDate)+1,1,year(WorkingDate))-1)
  Start#=(XDate#%7)+1
  Loop Block#=Start# to Kill#+Start#-1
    MonthText = CLIP(MonthText)&FORMAT(Block#-Start#+1,@n3)
    DG:ActualDate[Block#] = XDate#+Block#-Start#
    IF DG:ActualDate[Block#] = WorkingDate
      Cal2$?ActiveDay{PROP:Xpos} = DG:X[Block#]
      Cal2$?ActiveDay{PROP:Ypos} = DG:Y[Block#]
      COL# = DG:X[Block#]
      ROW# = DG:Y[Block#]
    END
  END
  MonthText = ALL(' ',Start#*3-2)&LEFT(MonthText)
  exit

PreLoad routine
  CLEAR(DateGroup)
  Block# = 1
  Loop Ycount#=0 to 5
    Loop Xcount#=0 to 6
      DG:X[Block#] = SUB('05172941536577',(Xcount#*2)+1,2)
      DG:Y[Block#] = SUB('273951637587',(Ycount#*2)+1,2)
      Block#+=1
    END
  END
  DO LoadMonth
  exit

FindMouseQ Routine
  FOUND# = 0
  CASE Xmouse
  OF 5 to 16
    Xaxis = 1
  OF 17 to 28
    Xaxis = 2
  OF 29 to 40
    Xaxis = 3
  OF 41 to 52
    Xaxis = 4
  OF 53 to 64
    Xaxis = 5
  OF 65 to 76
    Xaxis = 6
  OF 77 to 89
    Xaxis = 7
  END
  CASE Ymouse
  OF 27 to 38
    DGpointer = Xaxis
  OF 39 to 50
    DGpointer = Xaxis+7
  OF 51 to 62
    DGpointer = Xaxis+14
  OF 63 to 74
    DGpointer = Xaxis+21
  OF 75 to 86
    DGpointer = Xaxis+28
  OF 87 to 98
    DGpointer = Xaxis+35
  END
  IF DG:ActualDate[DGpointer]
    WorkingDate = DG:ActualDate[DGpointer]
    Cal2$?ActiveDay{PROP:Xpos} = DG:X[DGpointer]
    Cal2$?ActiveDay{PROP:Ypos} = DG:Y[DGpointer]
    COL# = DG:X[DGpointer]
    ROW# = DG:Y[DGpointer]
    FOUND# = 1
  END

TINCALENDARSTYLE3    FUNCTION (STARTTITLE,STARTDATE) ! Declare Procedure
WorkingDate LONG
WorkMonth   SHORT
Xaxis       SHORT
Xmouse      SHORT
Ymouse      SHORT
DGpointer   SHORT
DateGroup   Group,Pre(DG)
X             SHORT,DIM(42)
Y             SHORT,DIM(42)
ActualDate    LONG,DIM(42)
            END

MonthText   String(111)

Cal3 WINDOW('Calendar'),AT(,,125,103),CENTER,ALRT(PgUpKey),ALRT(CtrlPgUp),ALRT(PgDnKey),ALRT(CtrlPgDn), |
         ALRT(HomeKey),ALRT(LeftKey),ALRT(UpKey),ALRT(RightKey),ALRT(DownKey),ALRT(EnterKey),ALRT(EscKey), |
         GRAY,DOUBLE
       STRING(@s2),AT(7,29,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[1:3]),TRN
       STRING(@s14),AT(19,29,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[4:18]),TRN
       STRING(@s2),AT(79,29,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[19:20]),TRN
       STRING(@s2),AT(7,41,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[22:24]),TRN
       STRING(@s14),AT(19,41,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[25:39]),TRN
       STRING(@s2),AT(79,41,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[40:41]),TRN
       STRING(@s2),AT(7,53,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[43:45]),TRN
       STRING(@s14),AT(19,53,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[46:60]),TRN
       STRING(@s2),AT(79,53,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[61:62]),TRN
       STRING(@s2),AT(7,65,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[64:66]),TRN
       STRING(@s14),AT(19,65,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[67:81]),TRN
       STRING(@s2),AT(79,65,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[82:83]),TRN
       STRING(@s2),AT(7,77,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[85:87]),TRN
       STRING(@s14),AT(19,77,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[88:102]),TRN
       STRING(@s2),AT(79,77,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[103:104]),TRN
       STRING(@s2),AT(7,89,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[106:108]),TRN
       STRING(@s2),AT(19,89,12,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[109:111]),TRN
       STRING('Sun'),AT(5,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       STRING('Mon'),AT(17,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Tue'),AT(29,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Wed'),AT(41,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Thr'),AT(54,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Fri'),AT(65,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Sat'),AT(77,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       ENTRY(@s20),AT(6,5,83,10),FONT('Arial',8,,FONT:regular),USE(?ForLooksOnly),SKIP,DISABLE,CENTER
       REGION,AT(5,27,84,72),USE(?Region1),IMM
       BUTTON('&OK'),AT(94,68,26,10),FONT('Arial',8,,FONT:bold),USE(?OKButton),DEFAULT
       BUTTON('&Cancel'),AT(94,54,26,10),FONT('Arial',8,,FONT:bold),USE(?ExitNoDate)
       BUTTON('&Today'),AT(94,40,26,10),FONT('Arial',8,,FONT:bold),USE(?GoToday)
       BUTTON,AT(94,26,12,10),FONT('Arial',8,,FONT:bold),USE(?MonthMinus),ICON(ICON:VCRback)
       BUTTON,AT(108,26,12,10),FONT('Arial',8,,FONT:bold),USE(?MonthPlus),ICON(ICON:VCRplay)
       STRING(@d4),AT(16,7,61,7),FONT('Arial',8,,FONT:bold),USE(WorkingDate),TRN,CENTER
       LINE,AT(5,25,84,0),USE(?Line1),COLOR(0808080H)
       BOX,AT(5,27,12,12),USE(?ActiveDay),COLOR(0FF0000H),FILL(0FFFFFFH)
     END
  CODE                                            ! Begin processed code
  ROW# = 27
  COL# = 5

  IF OMITTED(2) OR ~StartDate THEN
    WORKINGDATE = TODAY()
  ELSE
    WorkingDate = StartDate
  END
  WorkMonth = Month(WorkingDate)

  OPEN(CAL3)
  IF ~OMITTED(1) AND STARTTITLE THEN
    CAL3{PROP:TEXT} = CLIP(STARTTITLE)
  END
  DO PreLoad
  ACCEPT

    DISPLAY(?WorkingDate)

    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:GainFocus
    OF EVENT:AlertKey
      CASE Keycode()
      OF RightKey
        DO NextDay
      OF LeftKey
        DO PrevDay
      OF DownKey
        DO NextWeek
      OF UpKey
        DO PrevWeek
      OF PgDnKey
        DO NextMonth
      OF PgUpKey
        DO PrevMonth
      OF HomeKey
        DO Set2Start
      OF CtrlPgDn
        DO NextYear
      OF CtrlPgUp
        DO PrevYear
      OF EnterKey
        DO EndProcedure
      OF EscKey
        WorkingDate = 0
        DO EndProcedure
      END
      CYCLE

    OF EVENT:MouseUp
      IF FIELD() = ?Region1
        IF MouseY()=Ymouse and MouseX()=Xmouse
          DO EndProcedure
        END
        Ymouse = MouseY()
        Xmouse = MouseX()
        DO FindMouseQ
        IF ~FOUND#
          Xmouse = 0
          Ymouse = 0
        END
        CYCLE
      END

    OF EVENT:Accepted
      CASE FIELD()
      OF ?MonthPlus
        DO NextMonth
      OF ?MonthMinus
        DO PrevMonth
      OF ?ExitNoDate
        WorkingDate = 0
        DO EndProcedure
      OF ?GoToday
        DO Set2Today
      OF ?OKButton
        DO EndProcedure
      END

    END
  END
  DO EndProcedure

EndProcedure Routine
  POST(EVENT:CloseWindow)
  RETURN(WorkingDate)

NextDay Routine
  WorkingDate += 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# += 12
  IF COL# > 77
    COL# = 5
    ROW# += 12
  END
  CAL3$?ActiveDay{PROP:Xpos} = COL#
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevDay Routine
  WorkingDate -= 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# -= 12
  IF COL# < 5
    COL# = 77
    ROW# -= 12
  END
  CAL3$?ActiveDay{PROP:Xpos} = COL#
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextWeek Routine
  WorkingDate += 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# += 12
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevWeek Routine
  WorkingDate -= 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# -= 12
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextMonth Routine

  WorkingDate=Date(WorkMonth+1,day(WorkingDate),year(WorkingDate))      !            But it works OK when month = 13
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevMonth Routine
  IF WorkMonth=1                                                        !Workaround: CW(1001) has a problem with its
    WorkingDate=Date(12,day(WorkingDate),year(WorkingDate)-1)           !            DATE() function when month = 0
  ELSE
    WorkingDate=Date(WorkMonth-1,day(WorkingDate),year(WorkingDate))
  END
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

NextYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)+1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)-1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Today Routine
  WorkingDate = TODAY()
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Start Routine
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

LoadMonth routine
  MonthText=''
  CLEAR(DG:ActualDate[])
  XDate#=date(month(WorkingDate),1,year(WorkingDate))
  Kill#=day(date(month(WorkingDate)+1,1,year(WorkingDate))-1)
  Start#=(XDate#%7)+1
  Loop Block#=Start# to Kill#+Start#-1
    MonthText = CLIP(MonthText)&FORMAT(Block#-Start#+1,@n3)
    DG:ActualDate[Block#] = XDate#+Block#-Start#
    IF DG:ActualDate[Block#] = WorkingDate
      CAL3$?ActiveDay{PROP:Xpos} = DG:X[Block#]
      CAL3$?ActiveDay{PROP:Ypos} = DG:Y[Block#]
      COL# = DG:X[Block#]
      ROW# = DG:Y[Block#]
    END
  END
  MonthText = ALL(' ',Start#*3-2)&LEFT(MonthText)
  exit

PreLoad routine
  CLEAR(DateGroup)
  Block# = 1
  Loop Ycount#=0 to 5
    Loop Xcount#=0 to 6
      DG:X[Block#] = SUB('05172941536577',(Xcount#*2)+1,2)
      DG:Y[Block#] = SUB('273951637587',(Ycount#*2)+1,2)
      Block#+=1
    END
  END
  DO LoadMonth
  exit

FindMouseQ Routine
  FOUND# = 0
  CASE Xmouse
  OF 5 to 16
    Xaxis = 1
  OF 17 to 28
    Xaxis = 2
  OF 29 to 40
    Xaxis = 3
  OF 41 to 52
    Xaxis = 4
  OF 53 to 64
    Xaxis = 5
  OF 65 to 76
    Xaxis = 6
  OF 77 to 89
    Xaxis = 7
  END
  CASE Ymouse
  OF 27 to 38
    DGpointer = Xaxis
  OF 39 to 50
    DGpointer = Xaxis+7
  OF 51 to 62
    DGpointer = Xaxis+14
  OF 63 to 74
    DGpointer = Xaxis+21
  OF 75 to 86
    DGpointer = Xaxis+28
  OF 87 to 98
    DGpointer = Xaxis+35
  END
  IF DG:ActualDate[DGpointer]
    WorkingDate = DG:ActualDate[DGpointer]
    CAL3$?ActiveDay{PROP:Xpos} = DG:X[DGpointer]
    CAL3$?ActiveDay{PROP:Ypos} = DG:Y[DGpointer]
    COL# = DG:X[DGpointer]
    ROW# = DG:Y[DGpointer]
    FOUND# = 1
  END

TINCALENDARSTYLE4    FUNCTION (STARTTITLE,STARTDATE) ! Declare Procedure
LOC:Days_of_Month    STRING(2),DIM(42)
LOC:Month_Group      GROUP,OVER(LOC:Days_of_Month),Pre()
LOC:Day1_of_Month    STRING(2)
LOC:Day2_of_Month    STRING(2)
LOC:Day3_of_Month    STRING(2)
LOC:Day4_of_Month    STRING(2)
LOC:Day5_of_Month    STRING(2)
LOC:Day6_of_Month    STRING(2)
LOC:Day7_of_Month    STRING(2)
LOC:Day8_of_Month    STRING(2)
LOC:Day9_of_Month    STRING(2)
LOC:Day10_of_Month   STRING(2)
LOC:Day11_of_Month   STRING(2)
LOC:Day12_of_Month   STRING(2)
LOC:Day13_of_Month   STRING(2)
LOC:Day14_of_Month   STRING(2)
LOC:Day15_of_Month   STRING(2)
LOC:Day16_of_Month   STRING(2)
LOC:Day17_of_Month   STRING(2)
LOC:Day18_of_Month   STRING(2)
LOC:Day19_of_Month   STRING(2)
LOC:Day20_of_Month   STRING(2)
LOC:Day21_of_Month   STRING(2)
LOC:Day22_of_Month   STRING(2)
LOC:Day23_of_Month   STRING(2)
LOC:Day24_of_Month   STRING(2)
LOC:Day25_of_Month   STRING(2)
LOC:Day26_of_Month   STRING(2)
LOC:Day27_of_Month   STRING(2)
LOC:Day28_of_Month   STRING(2)
LOC:Day29_of_Month   STRING(2)
LOC:Day30_of_Month   STRING(2)
LOC:Day31_of_Month   STRING(2)
LOC:Day32_of_Month   STRING(2)
LOC:Day33_of_Month   STRING(2)
LOC:Day34_of_Month   STRING(2)
LOC:Day35_of_Month   STRING(2)
LOC:Day36_of_Month   STRING(2)
LOC:Day37_of_Month   STRING(2)
LOC:Day38_of_Month   STRING(2)
LOC:Day39_of_Month   STRING(2)
LOC:Day40_of_Month   STRING(2)
LOC:Day41_of_Month   STRING(2)
LOC:Day42_of_Month   STRING(2)
                     END
LOC:Date             LONG
LOC:Disp_Month       STRING(9)
LOC:Date2            LONG
LOC:Month            STRING(9),DIM(12)
LOC:Month_Days       SHORT,DIM(12)
LOC:Num_Days         REAL
LOC:Year_Num         LONG
LOC:Month_Num        LONG
LOC:Color            LONG,DIM(42)
LOC:Hide             BYTE,DIM(42)
LocalRequest         LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG,AUTO
Label WINDOW('Calendar'),AT(53,33,133,82),FONT('Times New Roman',8,,),GRAY,DOUBLE,MASK,MODAL
       STRING(@s11),AT(23,0,,8),FONT(,,,FONT:bold),USE(LOC:Disp_Month)
       BOX,AT(92,16,36,43),USE(?Box1),COLOR(0A4A0A0H)
       STRING(@d1),AT(93,0,,8),FONT(,,,FONT:bold),USE(LOC:Date)
       STRING('Year'),AT(100,20,,8),USE(?String3)
       SPIN(@n4),AT(96,28,30,8),USE(LOC:Year_Num),CENTER,RANGE(1800,2099),STEP(1)
       STRING('Month'),AT(96,40,,8),USE(?String4)
       SPIN(@n2),AT(96,48,30,8),USE(LOC:Month_Num),CENTER,RANGE(0,13),STEP(1)
       STRING('Su  Mo Tu We Th  Fr  Sa'),AT(3,9,84,8),FONT('MS Sans Serif',8,0800000H,FONT:regular),USE(?String1)
       IMAGE('TINTODAY.ICO'),AT(25,50),USE(?Image1),HIDE
       STRING(@s2),AT(3,18,8,8),USE(LOC:Day1_of_Month),HIDE
       STRING(@s2),AT(15,18,8,8),USE(LOC:Day2_of_Month),HIDE
       STRING(@s2),AT(27,18,8,8),USE(LOC:Day3_of_Month),HIDE
       STRING(@s2),AT(39,18,8,8),USE(LOC:Day4_of_Month),HIDE
       STRING(@s2),AT(51,18,8,8),USE(LOC:Day5_of_Month),HIDE
       STRING(@s2),AT(63,18,8,8),USE(LOC:Day6_of_Month),HIDE
       STRING(@s2),AT(75,18,8,8),USE(LOC:Day7_of_Month),HIDE
       STRING(@s2),AT(3,29,8,8),USE(LOC:Day8_of_Month),HIDE
       STRING(@s2),AT(15,29,8,8),USE(LOC:Day9_of_Month),HIDE
       STRING(@s2),AT(27,29,8,8),USE(LOC:Day10_of_Month),HIDE
       STRING(@s2),AT(39,29,8,8),USE(LOC:Day11_of_Month),HIDE
       STRING(@s2),AT(51,29,8,8),USE(LOC:Day12_of_Month),HIDE
       STRING(@s2),AT(63,29,8,8),USE(LOC:Day13_of_Month),HIDE
       STRING(@s2),AT(75,29,8,8),USE(LOC:Day14_of_Month),HIDE
       STRING(@s2),AT(3,39,8,8),USE(LOC:Day15_of_Month),HIDE
       STRING(@s2),AT(15,39,8,8),USE(LOC:Day16_of_Month),HIDE
       STRING(@s2),AT(27,39,8,8),USE(LOC:Day17_of_Month),HIDE
       STRING(@s2),AT(39,39,8,8),USE(LOC:Day18_of_Month),HIDE
       STRING(@s2),AT(51,39,8,8),USE(LOC:Day19_of_Month),HIDE
       STRING(@s2),AT(63,39,8,8),USE(LOC:Day20_of_Month),HIDE
       STRING(@s2),AT(75,39,8,8),USE(LOC:Day21_of_Month),HIDE
       STRING(@s2),AT(3,50,8,8),USE(LOC:Day22_of_Month),HIDE
       STRING(@s2),AT(15,50,8,8),USE(LOC:Day23_of_Month),HIDE
       STRING(@s2),AT(27,50,8,8),USE(LOC:Day24_of_Month),HIDE
       STRING(@s2),AT(39,50,8,8),USE(LOC:Day25_of_Month),HIDE
       STRING(@s2),AT(51,50,8,8),USE(LOC:Day26_of_Month),HIDE
       STRING(@s2),AT(63,50,8,8),USE(LOC:Day27_of_Month),HIDE
       STRING(@s2),AT(75,50,8,8),USE(LOC:Day28_of_Month),HIDE
       STRING(@s2),AT(3,62,8,8),USE(LOC:Day29_of_Month),HIDE
       STRING(@s2),AT(15,62,8,8),USE(LOC:Day30_of_Month),HIDE
       STRING(@s2),AT(27,62,8,8),USE(LOC:Day31_of_Month),HIDE
       STRING(@s2),AT(39,62,8,8),USE(LOC:Day32_of_Month),HIDE
       STRING(@s2),AT(51,62,8,8),USE(LOC:Day33_of_Month),HIDE
       STRING(@s2),AT(63,62,8,8),USE(LOC:Day34_of_Month),HIDE
       STRING(@s2),AT(75,62,8,8),USE(LOC:Day35_of_Month),HIDE
       STRING(@s2),AT(3,73,8,8),USE(LOC:Day36_of_Month),HIDE
       STRING(@s2),AT(15,73,8,8),USE(LOC:Day37_of_Month),HIDE
       STRING(@s2),AT(27,73,8,8),USE(LOC:Day38_of_Month),HIDE
       STRING(@s2),AT(39,73,8,8),USE(LOC:Day39_of_Month),HIDE
       STRING(@s2),AT(51,73,8,8),USE(LOC:Day40_of_Month),HIDE
       STRING(@s2),AT(63,73,8,8),USE(LOC:Day41_of_Month),HIDE
       STRING(@s2),AT(75,73,8,8),USE(LOC:Day42_of_Month),HIDE
       REGION,AT(3,18,8,8),USE(?RLOC:Day1_of_Month)
       REGION,AT(15,18,8,8),USE(?RLOC:Day2_of_Month)
       REGION,AT(27,18,8,8),USE(?RLOC:Day3_of_Month)
       REGION,AT(39,18,8,8),USE(?RLOC:Day4_of_Month)
       REGION,AT(51,18,8,8),USE(?RLOC:Day5_of_Month)
       REGION,AT(63,18,8,8),USE(?RLOC:Day6_of_Month)
       REGION,AT(75,18,8,8),USE(?RLOC:Day7_of_Month)
       REGION,AT(3,29,8,8),USE(?RLOC:Day8_of_Month)
       REGION,AT(15,29,8,8),USE(?RLOC:Day9_of_Month)
       REGION,AT(27,29,8,8),USE(?RLOC:Day10_of_Month)
       REGION,AT(39,29,8,8),USE(?RLOC:Day11_of_Month)
       REGION,AT(51,29,8,8),USE(?RLOC:Day12_of_Month)
       REGION,AT(63,29,8,8),USE(?RLOC:Day13_of_Month)
       REGION,AT(75,29,8,8),USE(?RLOC:Day14_of_Month)
       REGION,AT(3,39,8,8),USE(?RLOC:Day15_of_Month)
       REGION,AT(15,39,8,8),USE(?RLOC:Day16_of_Month)
       REGION,AT(27,39,8,8),USE(?RLOC:Day17_of_Month)
       REGION,AT(39,39,8,8),USE(?RLOC:Day18_of_Month)
       REGION,AT(51,39,8,8),USE(?RLOC:Day19_of_Month)
       REGION,AT(63,39,8,8),USE(?RLOC:Day20_of_Month)
       REGION,AT(75,39,8,8),USE(?RLOC:Day21_of_Month)
       REGION,AT(3,50,8,8),USE(?RLOC:Day22_of_Month)
       REGION,AT(15,50,8,8),USE(?RLOC:Day23_of_Month)
       REGION,AT(27,50,8,8),USE(?RLOC:Day24_of_Month)
       REGION,AT(39,50,8,8),USE(?RLOC:Day25_of_Month)
       REGION,AT(51,50,8,8),USE(?RLOC:Day26_of_Month)
       REGION,AT(63,50,8,8),USE(?RLOC:Day27_of_Month)
       REGION,AT(75,50,8,8),USE(?RLOC:Day28_of_Month)
       REGION,AT(3,62,8,8),USE(?RLOC:Day29_of_Month)
       REGION,AT(15,62,8,8),USE(?RLOC:Day30_of_Month)
       REGION,AT(27,62,8,8),USE(?RLOC:Day31_of_Month)
       REGION,AT(39,62,8,8),USE(?RLOC:Day32_of_Month)
       REGION,AT(51,62,8,8),USE(?RLOC:Day33_of_Month)
       REGION,AT(63,62,8,8),USE(?RLOC:Day34_of_Month)
       REGION,AT(75,62,8,8),USE(?RLOC:Day35_of_Month)
       REGION,AT(3,73,8,8),USE(?RLOC:Day36_of_Month)
       REGION,AT(15,73,8,8),USE(?RLOC:Day37_of_Month)
       REGION,AT(27,73,8,8),USE(?RLOC:Day38_of_Month)
       REGION,AT(39,73,8,8),USE(?RLOC:Day39_of_Month)
       REGION,AT(51,73,8,8),USE(?RLOC:Day40_of_Month)
       REGION,AT(63,73,8,8),USE(?RLOC:Day41_of_Month)
       REGION,AT(75,73,8,8),USE(?RLOC:Day42_of_Month)
       BUTTON('Close'),AT(96,68,25,10),USE(?CloseButton)
     END
  CODE                                            ! Begin processed code
  DO CalSetup
  OPEN(Label)
  IF ~OMITTED(1) AND STARTTITLE THEN
    LABEL{PROP:TEXT} = CLIP(STARTTITLE)
  END
  WindowOpened=True
  ACCEPT
    CASE EVENT()
    OF Event:OpenWindow
      DO CalCalc
      DO RefreshWindow
      SELECT(FIRSTFIELD())
    END
    CASE ACCEPTED()
    OF ?RLOC:Day1_of_Month TO ?RLOC:Day42_of_Month
      ?Image1{ PROP:xPos } = (ACCEPTED(){ PROP:xPos } - 2)
      ?Image1{ PROP:yPos } = (ACCEPTED(){ PROP:yPos } - 1)
      UNHIDE(?Image1)
      Day# = LOC:Days_of_Month[ACCEPTED() - 51]            !Field #
      LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
    End
    CASE FIELD()
    OF ?RLOC:Day1_of_Month TO ?RLOC:Day42_of_Month
      CASE KEYCODE()
      OF MouseLeft2
      .
    OF ?LOC:Date
      CASE EVENT()
      OF Event:Accepted
          LOC:Month_Num = MONTH(LOC:Date)
          LOC:Year_Num  = YEAR(LOC:Date)
          Day# = DAY(LOC:Date)
          DO CalCalc
          SELECT(?CloseButton)
      END
    OF ?LOC:Year_Num
      CASE EVENT()
      OF Event:Accepted
        DO RefreshWindow
      OF Event:NewSelection
          DAY# = DAY(LOC:Date)
          LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
          DO CalCalc
      END
    OF ?LOC:Month_Num
      CASE EVENT()
      OF Event:Accepted
        DO RefreshWindow
      OF Event:NewSelection
          DAY# = DAY(LOC:Date)
          IF LOC:Month_Num = 0
            LOC:Month_Num = 12
            LOC:Year_Num -= 1
          .
          IF LOC:Month_Num = 13
            LOC:Month_Num = 1
            LOC:Year_Num += 1
          .
          DISPLAY
          LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
          DO CalCalc
      END
    OF ?CloseButton
      CASE EVENT()
      OF Event:Accepted
        DO RefreshWindow
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
! IF LocalResponse = 0
! END
  RETURN(LOC:DATE)
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  DISPLAY()
!---------------------------------------------------------------------------
CalSetup ROUTINE                                   ! Initialize Variables
  LOC:Month[1]  = 'January'
  LOC:Month[2]  = 'February'
  LOC:Month[3]  = 'March'
  LOC:Month[4]  = 'April'
  LOC:Month[5]  = 'May'
  LOC:Month[6]  = 'June'
  LOC:Month[7]  = 'July'
  LOC:Month[8]  = 'August'
  LOC:Month[9]  = 'September'
  LOC:Month[10] = 'October'
  LOC:Month[11] = 'November'
  LOC:Month[12] = 'December'
  LOC:Month_Days[1]  =   0
  LOC:Month_Days[2]  =  31
  LOC:Month_Days[3]  =  59
  LOC:Month_Days[4]  =  90
  LOC:Month_Days[5]  = 120
  LOC:Month_Days[6]  = 151
  LOC:Month_Days[7]  = 181
  LOC:Month_Days[8]  = 212
  LOC:Month_Days[9]  = 243
  LOC:Month_Days[10] = 273
  LOC:Month_Days[11] = 304
  LOC:Month_Days[12] = 334

  IF ~OMITTED(2) AND STARTDATE THEN
    LOC:Date = STARTDATE
  ELSE
    LOC:Date = Today()
  END
  LOC:Month_Num = MONTH(LOC:Date)
  LOC:Year_Num  = YEAR(LOC:Date)

CalCalc ROUTINE                                 !Calculate Calendar
  FirstDay# = DATE(LOC:Month_Num, 1, LOC:Year_Num)
  Day# = 1
  counter# = 1
  HIDE(?Image1)
  LOOP UNTIL counter# = 43
    LOC:Color[ counter# ] = 0
    counter# += 1
  .
  LOC:Disp_Month = Center(LOC:Month[ LOC:Month_Num ])
  Day_Num# = (FirstDay# % 7) + 1
  First_Cal# = FirstDay# - Day_Num# + 1
  counter# = 1
  LOOP UNTIL counter# = 43
    LOC:Hide[ counter# ] = 0
    LOC:Days_of_month[ counter# ] = DAY(First_Cal#)
    IF counter# < 7 AND LOC:Days_of_month[ counter# ] > 15  !Set to Hide
      LOC:Hide[ counter# ] = 1
    .
    IF counter# > 28 AND LOC:Days_of_month[ counter# ] < 15 !Set to Hide
      LOC:Hide[ counter# ] = 1
    .
    IF First_Cal# = TODAY()                                 !Today
        LOC:Color[ counter# ] = 000505C0h                   !red
       .
    First_Cal# += 1
    counter# += 1
  .
  c# = 1
  LOOP UNTIL c# = 43
    firstfld# = ?LOC:Day1_of_Month + c# - 1
    IF LOC:Color[c#] = 000505C0h
      IF ~ LOC:Hide[c#]
        ?Image1{ PROP:xPos } = (firstfld#{ PROP:xPos } - 2)
        ?Image1{ PROP:yPos } = (firstfld#{ PROP:yPos } - 1)
        UNHIDE(?Image1)
      .
    .
    firstfld#{ PROP:FontColor } = LOC:Color[c#]
    IF LOC:Hide[c#]
      HIDE(firstfld#)
      DISABLE(firstfld# + 42)
    ELSE
      UNHIDE(firstfld#)
      ENABLE(firstfld# + 42)
    .
    c# += 1
  .
CHECK_FIRST ROUTINE
  IF Day# > 8
    IF LOC:Month_Num = 1
      LOC:Month_Num = 12
      LOC:Year_Num -= 1
    ELSE
      LOC:Month_Num -= 1
    .
    LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
    DO CalCalc
  ELSE
    LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
    DISPLAY
  .
CHECK_LAST ROUTINE
  IF Day# < 15
    IF LOC:Month_Num = 12
      LOC:Month_Num = 1
      LOC:Year_Num += 1
    ELSE
      LOC:Month_Num += 1
    .
    LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
    DO CalCalc
  ELSE
    LOC:Date = DATE( LOC:Month_Num, Day#, LOC:Year_Num )
    DISPLAY
  .
CHK_DBL_CLK ROUTINE
  IF KEYCODE() = MouseLeft2
  .

TINCALENDARmonyear    FUNCTION (Passeddate)
! Extension Function: Original  Fingertips 1996-1997, Tim Down (100705.1546@compuserve.com)
! Added function by Carroll Jolly
! DESCRIPTION: Displays popup calendar window.  User can choose a date within 5 years with 3
!mouse clicks
!
! USAGE:       Calendar(LONG)    If starting date is omitted, defaults to current date.
! RETURNS:     LONG
!________________________________________________________________________________________________
!|                                 REVISIONS
!|                                 =========
!| DATE                 CHANGE                                
!|_______________________________________________________________________________________________
!| 07/10/96       1st Day of week changed to Sunday.          
!|
!| 22/11/96       Bevel to represent current day number       
!|                is carried from month to month when
!|                scrolling the months/years.
!Define Variables
MonthNumber    SHORT
YearNumber     SHORT
!Centyear       Short
Year1          short
Year2          Short
Year01         Short
Year02         Short
addyear        Long
!Define Window
Calmoyr WINDOW('Caption'),AT(,,162,145),FONT('MS Sans Serif',8,,FONT:regular),CENTER,ALRT(UpKey),ALRT(DownKey), |
         ALRT(PgUpKey),ALRT(PgDnKey),ALRT(EscKey),ALRT(RightKey),ALRT(LeftKey),ALRT(MouseRight),GRAY, |
         DOUBLE
       BUTTON('Jan'),AT(116,13,20,14),USE(?Jan)
       BUTTON('Feb'),AT(137,13,20,14),USE(?Feb)
       BUTTON('Mar'),AT(116,27,20,14),USE(?Mar)
       BUTTON('Apr'),AT(137,27,20,14),USE(?Apr)
       BUTTON('May'),AT(116,41,20,14),USE(?May)
       BUTTON('Jun'),AT(137,41,20,14),USE(?Jun)
       BUTTON('Jul'),AT(116,55,20,14),USE(?Jul)
       BUTTON('Aug'),AT(137,55,20,14),USE(?Aug)
       BUTTON('Sep'),AT(116,69,20,14),USE(?Sep)
       BUTTON('Oct'),AT(137,69,20,14),USE(?Oct)
       BUTTON('Nov'),AT(116,83,20,14),USE(?Nov)
       BUTTON('Dec'),AT(137,83,20,14),USE(?Dec)
       BUTTON('1999'),AT(136,106,20,14),USE(?year1)
       STRING('Centyear'),AT(119,120),FONT(,,080H,),USE(?centyear),CENTER
       BUTTON('1996'),AT(97,128,20,14),USE(?Year01)
       BUTTON('1997'),AT(97,106,20,14),USE(?Year02)
       BUTTON('2000'),AT(136,128,20,14),USE(?Year2)
       REGION,AT(94,103,66,41),USE(?Region39),BEVEL(5)
       STRING('Su'),AT(2,1,11,11),FONT(,,0FFH,),USE(?StringMo),CENTER
       STRING('Mo'),AT(17,1,11,11),FONT(,,0800000H,),USE(?StringTu),CENTER
       STRING('Tu'),AT(32,1,11,11),FONT(,,0800000H,),USE(?StringWe),CENTER
       STRING('We'),AT(47,1,11,11),FONT(,,0800000H,),USE(?StringTh),CENTER
       STRING('Th'),AT(62,1,11,11),FONT(,,0800000H,),USE(?StringFr),CENTER
       STRING('Fr'),AT(77,1,11,11),FONT(,,0800000H,),USE(?StringSa),CENTER
       STRING('Sa'),AT(92,1,11,11),FONT(,,0FFH,),USE(?StringSu),CENTER
       PANEL,AT(-1,2,107,12),USE(?Panel1),FULL,BEVEL(0,0,09H)
       REGION,AT(3,15,11,11),USE(?Region1),IMM
       REGION,AT(18,15,11,11),USE(?Region2),IMM
       REGION,AT(33,15,11,11),USE(?Region3),IMM
       REGION,AT(48,15,11,11),USE(?Region4),IMM
       REGION,AT(63,15,11,11),USE(?Region5),IMM
       REGION,AT(78,15,11,11),USE(?Region6),IMM
       REGION,AT(93,15,11,11),USE(?Region7),IMM
       REGION,AT(3,30,11,11),USE(?Region8),IMM
       REGION,AT(18,30,11,11),USE(?Region9),IMM
       REGION,AT(33,30,11,11),USE(?Region10),IMM
       REGION,AT(48,30,11,11),USE(?Region11),IMM
       REGION,AT(63,30,11,11),USE(?Region12),IMM
       REGION,AT(78,30,11,11),USE(?Region13),IMM
       REGION,AT(93,30,11,11),USE(?Region14),IMM
       REGION,AT(3,45,11,11),USE(?Region15),IMM
       REGION,AT(18,45,11,11),USE(?Region16),IMM
       REGION,AT(33,45,11,11),USE(?Region17),IMM
       REGION,AT(48,45,11,11),USE(?Region18),IMM
       REGION,AT(63,45,11,11),USE(?Region19),IMM
       REGION,AT(78,45,11,11),USE(?Region20),IMM
       REGION,AT(93,45,11,11),USE(?Region21),IMM
       REGION,AT(114,1,45,99),USE(?Region38),BEVEL(-5,4)
       STRING('Month'),AT(128,4),FONT(,,080H,),USE(?String46)
       REGION,AT(3,60,11,11),USE(?Region22),IMM
       REGION,AT(18,60,11,11),USE(?Region23),IMM
       REGION,AT(33,60,11,11),USE(?Region24),IMM
       REGION,AT(48,60,11,11),USE(?Region25),IMM
       REGION,AT(63,60,11,11),USE(?Region26),IMM
       REGION,AT(78,60,11,11),USE(?Region27),IMM
       REGION,AT(93,60,11,11),USE(?Region28),IMM
       REGION,AT(3,75,11,11),USE(?Region29),IMM
       REGION,AT(18,75,11,11),USE(?Region30),IMM
       REGION,AT(33,75,11,11),USE(?Region31),IMM
       REGION,AT(48,75,11,11),USE(?Region32),IMM
       REGION,AT(63,75,11,11),USE(?Region33),IMM
       REGION,AT(78,75,11,11),USE(?Region34),IMM
       REGION,AT(93,75,11,11),USE(?Region35),IMM
       REGION,AT(3,90,11,11),USE(?Region36),IMM
       REGION,AT(18,90,11,11),USE(?Region37),IMM
       STRING(''),AT(1,16,11,11),USE(?String1),TRN,RIGHT
       STRING(''),AT(16,16,11,11),USE(?String2),TRN,RIGHT
       STRING(''),AT(31,16,11,11),USE(?String3),TRN,RIGHT
       STRING(''),AT(46,16,11,11),USE(?String4),TRN,RIGHT
       STRING(''),AT(61,16,11,11),USE(?String5),TRN,RIGHT
       STRING(''),AT(76,16,11,11),USE(?String6),TRN,RIGHT
       STRING(''),AT(91,16,11,11),USE(?String7),TRN,RIGHT
       STRING(''),AT(1,31,11,11),USE(?String8),TRN,RIGHT
       STRING(''),AT(16,31,11,11),USE(?String9),TRN,RIGHT
       STRING(''),AT(31,31,11,11),USE(?String10),TRN,RIGHT
       STRING(''),AT(46,31,11,11),USE(?String11),TRN,RIGHT
       STRING(''),AT(61,31,11,11),USE(?String12),TRN,RIGHT
       STRING(''),AT(76,31,11,11),USE(?String13),TRN,RIGHT
       STRING(''),AT(91,31,11,11),USE(?String14),TRN,RIGHT
       STRING(''),AT(1,46,11,11),USE(?String15),TRN,RIGHT
       STRING(''),AT(16,46,11,11),USE(?String16),TRN,RIGHT
       STRING(''),AT(31,46,11,11),USE(?String17),TRN,RIGHT
       STRING(''),AT(46,46,11,11),USE(?String18),TRN,RIGHT
       STRING(''),AT(61,46,11,11),USE(?String19),TRN,RIGHT
       STRING(''),AT(76,46,11,11),USE(?String20),TRN,RIGHT
       STRING(''),AT(91,46,11,11),USE(?String21),TRN,RIGHT
       STRING(''),AT(1,61,11,11),USE(?String22),TRN,RIGHT
       STRING(''),AT(16,61,11,11),USE(?String23),TRN,RIGHT
       STRING(''),AT(31,61,11,11),USE(?String24),TRN,RIGHT
       STRING(''),AT(46,61,11,11),USE(?String25),TRN,RIGHT
       STRING(''),AT(61,61,11,11),USE(?String26),TRN,RIGHT
       STRING(''),AT(76,61,11,11),USE(?String27),TRN,RIGHT
       STRING(''),AT(91,61,11,11),USE(?String28),TRN,RIGHT
       STRING(''),AT(1,76,11,11),USE(?String29),TRN,RIGHT
       STRING(''),AT(16,76,11,11),USE(?String30),TRN,RIGHT
       STRING(''),AT(31,76,11,11),USE(?String31),TRN,RIGHT
       STRING(''),AT(46,76,11,11),USE(?String32),TRN,RIGHT
       STRING(''),AT(61,76,11,11),USE(?String33),TRN,RIGHT
       STRING(''),AT(76,76,11,11),USE(?String34),TRN,RIGHT
       STRING(''),AT(91,76,11,11),USE(?String35),TRN,RIGHT
       STRING(''),AT(2,91,11,11),USE(?String36),TRN,RIGHT
       STRING(''),AT(16,91,11,11),USE(?String37),TRN,RIGHT
     END
  CODE                                            ! Begin processed code
!Open Calendar Window
  PUSHBIND
   OPEN(Calmoyr)
  !Set up initial display
    IF PassedDate = ''         !If no date was passed default to current date
     PassedDate=Today()
  END
  MonthNumber = MONTH(PassedDate)
  YearNumber = YEAR(PassedDate)
  DO SetWindowTitle
  DO AssignAllStrings
  DO HighlightPassedDate
  ACCEPT
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
         OF UpKey OROF LeftKey
            MonthNumber -=1
         OF DownKey OROF RightKey
            MonthNumber +=1
         OF PgUpKey
            YearNumber -= 1
         OF PgDnKey
            YearNumber += 1
         OF EscKey                   !Close, returning passed date or default current date
            POPBIND
            RETURN(PassedDate)
         OF MouseRight               !Close, returning passed date or default current date
            POPBIND
            RETURN(PassedDate)
      END!CASE KEYCODE
      IF    MonthNumber > 12
            MonthNumber = 1
            YearNumber +=1
      ELSIF MonthNumber < 1
            MonthNumber = 12
            YearNumber -=1
      END!IF
      DO CheckRange
      DO SetWindowTitle
      DO ClearHighlight
      DO AssignAllStrings
      DO HighlightPassedDate
    END!CASE EVENT
    CASE FIELD()
   OF ?Jan
      CASE EVENT()
      OF EVENT:Accepted
            monthnumber=1
            DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
         END
   OF ?Feb
      CASE EVENT()
      OF EVENT:Accepted
            monthnumber=2
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Mar
      CASE EVENT()
      OF EVENT:Accepted
         monthnumber=3
   
     DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Apr
      CASE EVENT()
      OF EVENT:Accepted
             monthnumber=4
         DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?May
      CASE EVENT()
      OF EVENT:Accepted
         monthnumber=5
         DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Jun
      CASE EVENT()
      OF EVENT:Accepted
           monthnumber=6
          DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
     OF ?Jul
      CASE EVENT()
      OF EVENT:Accepted
         monthnumber=7
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Aug
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=8
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Sep
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=9
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Oct
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=10
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Nov
      CASE EVENT()
      OF EVENT:Accepted
          monthnumber=11
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Dec
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=12
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
      OF ?Year01
      CASE EVENT()
      OF EVENT:Accepted
       Yearnumber=Yearnumber-1
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
        Do Yearbutton
         end
     OF ?Year02
      CASE EVENT()
      OF EVENT:Accepted
      Yearnumber=Yearnumber-2
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
        DO Yearbutton
      END
    OF ?Year1
      CASE EVENT()
      OF EVENT:Accepted
       Yearnumber=Yearnumber+1
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
        DO Yearbutton
      END
    OF ?Year2
      CASE EVENT()
      OF EVENT:Accepted
         Yearnumber=Yearnumber+2
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
        DO Yearbutton
      END
      OF ?Region1
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String1{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String1{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
         END
      END
    OF ?Region2
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String2{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String2{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region3
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String3{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String3{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region4
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String4{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String4{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region5
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String5{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String5{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region6
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String6{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String6{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region7
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String7{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region8
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String8{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region9
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String9{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region10
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String10{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region11
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String11{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region12
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String12{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region13
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String13{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region14
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String14{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region15
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String15{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region16
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String16{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region17
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String17{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region18
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String18{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region19
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String19{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region20
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String20{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region21
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String21{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region22
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String22{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region23
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String23{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region24
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String24{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region25
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String25{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region26
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String26{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region27
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String27{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region28
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String28{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region29
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String29{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String29{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region30
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String30{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String30{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region31
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String31{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String31{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region32
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String32{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String32{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region33
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String33{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String33{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region34
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String34{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String34{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region35
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String35{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String35{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region36
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String36{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String36{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region37
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String37{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String37{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    END!CASE FIELD
  END!ACCEPT LOOP
!------------------------------------------------------------------------------------------------
SetWindowTitle ROUTINE
!|Set up the window title
    CASE MonthNumber
         OF  1
             Calmoyr{PROP:TEXT}='January ' &YearNumber
         OF  2
             Calmoyr{PROP:TEXT}='February ' &YearNumber
         OF  3
             Calmoyr{PROP:TEXT}='March ' &YearNumber
         OF  4
             Calmoyr{PROP:TEXT}='April ' &YearNumber
         OF  5
             Calmoyr{PROP:TEXT}='May ' &YearNumber
         OF  6
             Calmoyr{PROP:TEXT}='June ' &YearNumber
         OF  7
             Calmoyr{PROP:TEXT}='July ' &YearNumber
         OF  8
             Calmoyr{PROP:TEXT}='August ' &YearNumber
         OF  9
             Calmoyr{PROP:TEXT}='September ' &YearNumber
         OF  10
             Calmoyr{PROP:TEXT}='October ' &YearNumber
         OF  11
             Calmoyr{PROP:TEXT}='November ' &YearNumber
         OF  12
             Calmoyr{PROP:TEXT}='December ' &YearNumber
    END!CASE
!|----------------------------------------------------------------------------------------------
AssignAllStrings ROUTINE
!|Redraws the calendar for the current month
!|
   !How many days are there in this month?
   CASE MonthNumber
     OF     9                           !Short months
     OROF   4
     OROF   6
     OROF   11
            MaxDays#=30                 
     OF     2                           !If the month is February
            IF YearNumber % 4 = 0       !If a leap year
               MaxDays# = 29            
            ELSE
               MaxDays# = 28
            END!IF
     ELSE   MaxDays# = 31               !Standard months
   END!CASE
   !Find what day the first of this month falls on.
   CASE DEFORMAT(('1/' &MonthNumber &'/' &YearNumber),@D6) % 7
      OF 0                              !Month starts on a Sunday
         ?String1{PROP:TEXT} = '1'      
         ?String2{PROP:TEXT} = '2'
         ?String3{PROP:TEXT} = '3'
         ?String4{PROP:TEXT} = '4'
         ?String5{PROP:TEXT} = '5'
         ?String6{PROP:TEXT} = '6'
         ?String7{PROP:TEXT} = '7'
      OF 1                              !Month starts on a Monday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = '1'
         ?String3{PROP:TEXT} = '2'
         ?String4{PROP:TEXT} = '3'
         ?String5{PROP:TEXT} = '4'
         ?String6{PROP:TEXT} = '5'
         ?String7{PROP:TEXT} = '6'
      OF 2                              !Month starts on a Tuesday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = '1'
         ?String4{PROP:TEXT} = '2'
         ?String5{PROP:TEXT} = '3'
         ?String6{PROP:TEXT} = '4'
         ?String7{PROP:TEXT} = '5'
      OF 3                              !Month starts on a Wednesday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = '1'
         ?String5{PROP:TEXT} = '2'
         ?String6{PROP:TEXT} = '3'
         ?String7{PROP:TEXT} = '4'
      OF 4                              !Month starts on a Thursday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = '1'
         ?String6{PROP:TEXT} = '2'
         ?String7{PROP:TEXT} = '3'
      OF 5                              !Month starts on a Friday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = ''
         ?String6{PROP:TEXT} = '1'
         ?String7{PROP:TEXT} = '2'
      OF 6                              !Month starts on a Saturday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = ''
         ?String6{PROP:TEXT} = ''
         ?String7{PROP:TEXT} = '1'
   END
  !Format the strings for the rest of the current month.
  !From day 8 to 28 just add 1 to the previous string, then
  !start checking for potential last day of month from string 29 onwards
  ?String8{PROP:TEXT} = DEFORMAT(?String7{PROP:TEXT},@n2) + 1
  ?String9{PROP:TEXT} = DEFORMAT(?String8{PROP:TEXT},@n2) + 1
  ?String10{PROP:TEXT} = DEFORMAT(?String9{PROP:TEXT},@n2) + 1
  ?String11{PROP:TEXT} = DEFORMAT(?String10{PROP:TEXT},@n2) + 1
  ?String12{PROP:TEXT} = DEFORMAT(?String11{PROP:TEXT},@n2) + 1
  ?String13{PROP:TEXT} = DEFORMAT(?String12{PROP:TEXT},@n2) + 1
  ?String14{PROP:TEXT} = DEFORMAT(?String13{PROP:TEXT},@n2) + 1
  ?String15{PROP:TEXT} = DEFORMAT(?String14{PROP:TEXT},@n2) + 1
  ?String16{PROP:TEXT} = DEFORMAT(?String15{PROP:TEXT},@n2) + 1
  ?String17{PROP:TEXT} = DEFORMAT(?String16{PROP:TEXT},@n2) + 1
  ?String18{PROP:TEXT} = DEFORMAT(?String17{PROP:TEXT},@n2) + 1
  ?String19{PROP:TEXT} = DEFORMAT(?String18{PROP:TEXT},@n2) + 1
  ?String20{PROP:TEXT} = DEFORMAT(?String19{PROP:TEXT},@n2) + 1
  ?String21{PROP:TEXT} = DEFORMAT(?String20{PROP:TEXT},@n2) + 1
  ?String22{PROP:TEXT} = DEFORMAT(?String21{PROP:TEXT},@n2) + 1
  ?String23{PROP:TEXT} = DEFORMAT(?String22{PROP:TEXT},@n2) + 1
  ?String24{PROP:TEXT} = DEFORMAT(?String23{PROP:TEXT},@n2) + 1
  ?String25{PROP:TEXT} = DEFORMAT(?String24{PROP:TEXT},@n2) + 1
  ?String26{PROP:TEXT} = DEFORMAT(?String25{PROP:TEXT},@n2) + 1
  ?String27{PROP:TEXT} = DEFORMAT(?String26{PROP:TEXT},@n2) + 1
  ?String28{PROP:TEXT} = DEFORMAT(?String27{PROP:TEXT},@n2) + 1
  IF (DEFORMAT(?String28{PROP:TEXT},@n2) + 1) NOT > Maxdays#
     ?String29{PROP:TEXT} = DEFORMAT(?String28{PROP:TEXT},@n2) + 1
  ELSE
     ?String29{PROP:TEXT} = ''
  END
  IF ?String29{PROP:TEXT} <> '' AND (DEFORMAT(?String29{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String30{PROP:TEXT} = DEFORMAT(?String29{PROP:TEXT},@n2) + 1
  ELSE
     ?String30{PROP:TEXT} = ''
  END
  IF ?String30{PROP:TEXT} <> '' AND (DEFORMAT(?String30{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String31{PROP:TEXT} = DEFORMAT(?String30{PROP:TEXT},@n2) + 1
  ELSE
     ?String31{PROP:TEXT} = ''
  END
  IF ?String31{PROP:TEXT} <> '' AND (DEFORMAT(?String31{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String32{PROP:TEXT} = DEFORMAT(?String31{PROP:TEXT},@n2) + 1
  ELSE
     ?String32{PROP:TEXT} = ''
  END
  IF ?String32{PROP:TEXT} <> '' AND (DEFORMAT(?String32{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String33{PROP:TEXT} = DEFORMAT(?String32{PROP:TEXT},@n2) + 1
  ELSE
     ?String33{PROP:TEXT} = ''
  END
  IF ?String33{PROP:TEXT} <> '' AND (DEFORMAT(?String33{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String34{PROP:TEXT} = DEFORMAT(?String33{PROP:TEXT},@n2) + 1
  ELSE
     ?String34{PROP:TEXT} = ''
  END
  IF ?String34{PROP:TEXT} <> '' AND (DEFORMAT(?String34{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String35{PROP:TEXT} = DEFORMAT(?String34{PROP:TEXT},@n2) + 1
  ELSE
     ?String35{PROP:TEXT} = ''
  END
  IF ?String35{PROP:TEXT} <> '' AND (DEFORMAT(?String35{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String36{PROP:TEXT} = DEFORMAT(?String35{PROP:TEXT},@n2) + 1
  ELSE
     ?String36{PROP:TEXT} = ''
  END
  IF ?String36{PROP:TEXT} <> '' AND (DEFORMAT(?String36{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String37{PROP:TEXT} = DEFORMAT(?String36{PROP:TEXT},@n2) + 1
  ELSE
     ?String37{PROP:TEXT} = ''
  END
!|-------------------------------------------------------------------------------------------
HighlightPassedDate ROUTINE
!| Bevel the region representing the passed date
!|
   IF DAY(PassedDate) > MaxDays# THEN EXIT      !Added this line so if day is
   END                                          !beyond max in new month = no bevel
   CASE DAY(PassedDate)
   OF ?String1{PROP:TEXT}
      ?Region1{PROP:BEVEL} = -1
   OF ?String2{PROP:TEXT}
      ?Region2{PROP:BEVEL} = -1
   OF ?String3{PROP:TEXT}
      ?Region3{PROP:BEVEL} = -1
   OF ?String4{PROP:TEXT}
      ?Region4{PROP:BEVEL} = -1
   OF ?String5{PROP:TEXT}
      ?Region5{PROP:BEVEL} = -1
   OF ?String6{PROP:TEXT}
      ?Region6{PROP:BEVEL} = -1
   OF ?String7{PROP:TEXT}
      ?Region7{PROP:BEVEL} = -1
   OF ?String8{PROP:TEXT}
      ?Region8{PROP:BEVEL} = -1
   OF ?String9{PROP:TEXT}
      ?Region9{PROP:BEVEL} = -1
   OF ?String10{PROP:TEXT}
      ?Region10{PROP:BEVEL} = -1
   OF ?String11{PROP:TEXT}
      ?Region11{PROP:BEVEL} = -1
   OF ?String12{PROP:TEXT}
      ?Region12{PROP:BEVEL} = -1
   OF ?String13{PROP:TEXT}
      ?Region13{PROP:BEVEL} = -1
   OF ?String14{PROP:TEXT}
      ?Region14{PROP:BEVEL} = -1
   OF ?String15{PROP:TEXT}
      ?Region15{PROP:BEVEL} = -1
   OF ?String16{PROP:TEXT}
      ?Region16{PROP:BEVEL} = -1
   OF ?String17{PROP:TEXT}
      ?Region17{PROP:BEVEL} = -1
   OF ?String18{PROP:TEXT}
      ?Region18{PROP:BEVEL} = -1
   OF ?String19{PROP:TEXT}
      ?Region19{PROP:BEVEL} = -1
   OF ?String20{PROP:TEXT}
      ?Region20{PROP:BEVEL} = -1
   OF ?String21{PROP:TEXT}
      ?Region21{PROP:BEVEL} = -1
   OF ?String22{PROP:TEXT}
      ?Region22{PROP:BEVEL} = -1
   OF ?String23{PROP:TEXT}
      ?Region23{PROP:BEVEL} = -1
   OF ?String24{PROP:TEXT}
      ?Region24{PROP:BEVEL} = -1
   OF ?String25{PROP:TEXT}
      ?Region25{PROP:BEVEL} = -1
   OF ?String26{PROP:TEXT}
      ?Region26{PROP:BEVEL} = -1
   OF ?String27{PROP:TEXT}
      ?Region27{PROP:BEVEL} = -1
   OF ?String28{PROP:TEXT}
      ?Region28{PROP:BEVEL} = -1
   OF ?String29{PROP:TEXT}
      ?Region29{PROP:BEVEL} = -1
   OF ?String30{PROP:TEXT}
      ?Region30{PROP:BEVEL} = -1
   OF ?String31{PROP:TEXT}
      ?Region31{PROP:BEVEL} = -1
   OF ?String32{PROP:TEXT}
      ?Region32{PROP:BEVEL} = -1
   OF ?String33{PROP:TEXT}
      ?Region33{PROP:BEVEL} = -1
   OF ?String34{PROP:TEXT}
      ?Region34{PROP:BEVEL} = -1
   OF ?String35{PROP:TEXT}
      ?Region35{PROP:BEVEL} = -1
   OF ?String36{PROP:TEXT}
      ?Region36{PROP:BEVEL} = -1
   OF ?String37{PROP:TEXT}
      ?Region37{PROP:BEVEL} = -1
   END!CASE
!|--------------------------------------------------------------------------------------------
ClearHighlight ROUTINE
!| Clear any Bevels
!|
   IF ?Region1{PROP:BEVEL} <> 0 THEN ?Region1{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region2{PROP:BEVEL} <> 0 THEN ?Region2{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region3{PROP:BEVEL} <> 0 THEN ?Region3{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region4{PROP:BEVEL} <> 0 THEN ?Region4{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region5{PROP:BEVEL} <> 0 THEN ?Region5{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region6{PROP:BEVEL} <> 0 THEN ?Region6{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region7{PROP:BEVEL} <> 0 THEN ?Region7{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region8{PROP:BEVEL} <> 0 THEN ?Region8{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region9{PROP:BEVEL} <> 0 THEN ?Region9{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region10{PROP:BEVEL} <> 0 THEN ?Region10{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region11{PROP:BEVEL} <> 0 THEN ?Region11{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region12{PROP:BEVEL} <> 0 THEN ?Region12{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region13{PROP:BEVEL} <> 0 THEN ?Region13{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region14{PROP:BEVEL} <> 0 THEN ?Region14{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region15{PROP:BEVEL} <> 0 THEN ?Region15{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region16{PROP:BEVEL} <> 0 THEN ?Region16{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region17{PROP:BEVEL} <> 0 THEN ?Region17{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region18{PROP:BEVEL} <> 0 THEN ?Region18{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region19{PROP:BEVEL} <> 0 THEN ?Region19{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region20{PROP:BEVEL} <> 0 THEN ?Region20{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region21{PROP:BEVEL} <> 0 THEN ?Region21{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region22{PROP:BEVEL} <> 0 THEN ?Region22{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region23{PROP:BEVEL} <> 0 THEN ?Region23{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region24{PROP:BEVEL} <> 0 THEN ?Region24{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region25{PROP:BEVEL} <> 0 THEN ?Region25{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region26{PROP:BEVEL} <> 0 THEN ?Region26{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region27{PROP:BEVEL} <> 0 THEN ?Region27{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region28{PROP:BEVEL} <> 0 THEN ?Region28{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region29{PROP:BEVEL} <> 0 THEN ?Region29{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region30{PROP:BEVEL} <> 0 THEN ?Region30{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region31{PROP:BEVEL} <> 0 THEN ?Region31{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region32{PROP:BEVEL} <> 0 THEN ?Region32{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region33{PROP:BEVEL} <> 0 THEN ?Region33{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region34{PROP:BEVEL} <> 0 THEN ?Region34{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region35{PROP:BEVEL} <> 0 THEN ?Region35{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region36{PROP:BEVEL} <> 0 THEN ?Region36{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region37{PROP:BEVEL} <> 0 THEN ?Region37{PROP:BEVEL} = 0
      EXIT
   END
!|---------------------------------------------------------======------------------
CheckRange ROUTINE
!|Gives error message if year is out of range
!|
  IF    YearNumber < 1801
        YearNumber = 1801
        MESSAGE('You cannot use the calendar for<13,10>'&|
        'dates before the year 1801', |
        'Date Out Of Range', Icon:Asterisk, |
        Button:Ok, Button:Ok, 0)
  ELSIF YearNumber > 2099
        YearNumber = 2099
        MESSAGE('You cannot use the calendar for<13,10>'&|
        'dates after the year 2099', |
        'Date Out Of Range', Icon:Asterisk, |
        Button:Ok, Button:Ok, 0)
  END
!|--------------------------------------------------------------------------------
!|--------------------------------------------------------------------------------
Yearbutton Routine
 !! Routine to change values of Buttons
   
  ?Year01{prop:text}=Yearnumber-1
  ?year02{prop:text}=yearnumber-2
  ?year1{prop:text}= yearnumber+1
  ?year2{prop:text}= yearnumber+2
    ?centyear{Prop:Text}=yearnumber
        display()


TINCALENDARMonth  FUNCTION (Passeddate)
! Extension Function: Original  Fingertips 1996-1997, Tim Down (100705.1546@compuserve.com)
!  Added function by Carroll Jolly
!  DESCRIPTION: Displays popup calendar window.  This is for data that is always within a year
!  and only the month is chosen
! USAGE:       Calendar(LONG)    If starting date is omitted, defaults to current date.
! RETURNS:     LONG
!________________________________________________________________________________________________
!|                                 REVISIONS
!|                                 =========
!| DATE                 CHANGE                                
!|_______________________________________________________________________________________________
!| 07/10/96       1st Day of week changed to Sunday.          
!|
!| 22/11/96       Bevel to represent current day number       
!|                is carried from month to month when
!|                scrolling the months/years.
!Define Variables
MonthNumber    SHORT
YearNumber     SHORT
!Centyear       Short
!Define Window
Calmo WINDOW('Caption'),AT(,,162,102),FONT('MS Sans Serif',8,,FONT:regular),CENTER,ALRT(UpKey),ALRT(DownKey), |
         ALRT(PgUpKey),ALRT(PgDnKey),ALRT(EscKey),ALRT(RightKey),ALRT(LeftKey),ALRT(MouseRight),GRAY, |
         DOUBLE
       BUTTON('Jan'),AT(116,13,20,14),USE(?Jan)
       BUTTON('Feb'),AT(137,13,20,14),USE(?Feb)
       BUTTON('Mar'),AT(116,27,20,14),USE(?Mar)
       BUTTON('Apr'),AT(137,27,20,14),USE(?Apr)
       BUTTON('May'),AT(116,41,20,14),USE(?May)
       BUTTON('Jun'),AT(137,41,20,14),USE(?Jun)
       BUTTON('Jul'),AT(116,55,20,14),USE(?Jul)
       BUTTON('Aug'),AT(137,55,20,14),USE(?Aug)
       BUTTON('Sep'),AT(116,69,20,14),USE(?Sep)
       BUTTON('Oct'),AT(137,69,20,14),USE(?Oct)
       BUTTON('Nov'),AT(116,83,20,14),USE(?Nov)
       BUTTON('Dec'),AT(137,83,20,14),USE(?Dec)
       STRING('Su'),AT(2,1,11,11),FONT(,,0FFH,),USE(?StringMo),CENTER
       STRING('Mo'),AT(17,1,11,11),FONT(,,0800000H,),USE(?StringTu),CENTER
       STRING('Tu'),AT(32,1,11,11),FONT(,,0800000H,),USE(?StringWe),CENTER
       STRING('We'),AT(47,1,11,11),FONT(,,0800000H,),USE(?StringTh),CENTER
       STRING('Th'),AT(62,1,11,11),FONT(,,0800000H,),USE(?StringFr),CENTER
       STRING('Fr'),AT(77,1,11,11),FONT(,,0800000H,),USE(?StringSa),CENTER
       STRING('Sa'),AT(92,1,11,11),FONT(,,0FFH,),USE(?StringSu),CENTER
       PANEL,AT(-1,2,107,12),USE(?Panel1),FULL,BEVEL(0,0,09H)
       REGION,AT(3,15,11,11),USE(?Region1),IMM
       REGION,AT(18,15,11,11),USE(?Region2),IMM
       REGION,AT(33,15,11,11),USE(?Region3),IMM
       REGION,AT(48,15,11,11),USE(?Region4),IMM
       REGION,AT(63,15,11,11),USE(?Region5),IMM
       REGION,AT(78,15,11,11),USE(?Region6),IMM
       REGION,AT(93,15,11,11),USE(?Region7),IMM
       REGION,AT(3,30,11,11),USE(?Region8),IMM
       REGION,AT(18,30,11,11),USE(?Region9),IMM
       REGION,AT(33,30,11,11),USE(?Region10),IMM
       REGION,AT(48,30,11,11),USE(?Region11),IMM
       REGION,AT(63,30,11,11),USE(?Region12),IMM
       REGION,AT(78,30,11,11),USE(?Region13),IMM
       REGION,AT(93,30,11,11),USE(?Region14),IMM
       REGION,AT(3,45,11,11),USE(?Region15),IMM
       REGION,AT(18,45,11,11),USE(?Region16),IMM
       REGION,AT(33,45,11,11),USE(?Region17),IMM
       REGION,AT(48,45,11,11),USE(?Region18),IMM
       REGION,AT(63,45,11,11),USE(?Region19),IMM
       REGION,AT(78,45,11,11),USE(?Region20),IMM
       REGION,AT(93,45,11,11),USE(?Region21),IMM
       REGION,AT(114,1,45,99),USE(?Region38),BEVEL(-5,4)
       STRING('Month'),AT(128,4),FONT(,,080H,),USE(?String46)
       REGION,AT(3,60,11,11),USE(?Region22),IMM
       REGION,AT(18,60,11,11),USE(?Region23),IMM
       REGION,AT(33,60,11,11),USE(?Region24),IMM
       REGION,AT(48,60,11,11),USE(?Region25),IMM
       REGION,AT(63,60,11,11),USE(?Region26),IMM
       REGION,AT(78,60,11,11),USE(?Region27),IMM
       REGION,AT(93,60,11,11),USE(?Region28),IMM
       REGION,AT(3,75,11,11),USE(?Region29),IMM
       REGION,AT(18,75,11,11),USE(?Region30),IMM
       REGION,AT(33,75,11,11),USE(?Region31),IMM
       REGION,AT(48,75,11,11),USE(?Region32),IMM
       REGION,AT(63,75,11,11),USE(?Region33),IMM
       REGION,AT(78,75,11,11),USE(?Region34),IMM
       REGION,AT(93,75,11,11),USE(?Region35),IMM
       REGION,AT(3,90,11,11),USE(?Region36),IMM
       REGION,AT(18,90,11,11),USE(?Region37),IMM
       STRING(''),AT(1,16,11,11),USE(?String1),TRN,RIGHT
       STRING(''),AT(16,16,11,11),USE(?String2),TRN,RIGHT
       STRING(''),AT(31,16,11,11),USE(?String3),TRN,RIGHT
       STRING(''),AT(46,16,11,11),USE(?String4),TRN,RIGHT
       STRING(''),AT(61,16,11,11),USE(?String5),TRN,RIGHT
       STRING(''),AT(76,16,11,11),USE(?String6),TRN,RIGHT
       STRING(''),AT(91,16,11,11),USE(?String7),TRN,RIGHT
       STRING(''),AT(1,31,11,11),USE(?String8),TRN,RIGHT
       STRING(''),AT(16,31,11,11),USE(?String9),TRN,RIGHT
       STRING(''),AT(31,31,11,11),USE(?String10),TRN,RIGHT
       STRING(''),AT(46,31,11,11),USE(?String11),TRN,RIGHT
       STRING(''),AT(61,31,11,11),USE(?String12),TRN,RIGHT
       STRING(''),AT(76,31,11,11),USE(?String13),TRN,RIGHT
       STRING(''),AT(91,31,11,11),USE(?String14),TRN,RIGHT
       STRING(''),AT(1,46,11,11),USE(?String15),TRN,RIGHT
       STRING(''),AT(16,46,11,11),USE(?String16),TRN,RIGHT
       STRING(''),AT(31,46,11,11),USE(?String17),TRN,RIGHT
       STRING(''),AT(46,46,11,11),USE(?String18),TRN,RIGHT
       STRING(''),AT(61,46,11,11),USE(?String19),TRN,RIGHT
       STRING(''),AT(76,46,11,11),USE(?String20),TRN,RIGHT
       STRING(''),AT(91,46,11,11),USE(?String21),TRN,RIGHT
       STRING(''),AT(1,61,11,11),USE(?String22),TRN,RIGHT
       STRING(''),AT(16,61,11,11),USE(?String23),TRN,RIGHT
       STRING(''),AT(31,61,11,11),USE(?String24),TRN,RIGHT
       STRING(''),AT(46,61,11,11),USE(?String25),TRN,RIGHT
       STRING(''),AT(61,61,11,11),USE(?String26),TRN,RIGHT
       STRING(''),AT(76,61,11,11),USE(?String27),TRN,RIGHT
       STRING(''),AT(91,61,11,11),USE(?String28),TRN,RIGHT
       STRING(''),AT(1,76,11,11),USE(?String29),TRN,RIGHT
       STRING(''),AT(16,76,11,11),USE(?String30),TRN,RIGHT
       STRING(''),AT(31,76,11,11),USE(?String31),TRN,RIGHT
       STRING(''),AT(46,76,11,11),USE(?String32),TRN,RIGHT
       STRING(''),AT(61,76,11,11),USE(?String33),TRN,RIGHT
       STRING(''),AT(76,76,11,11),USE(?String34),TRN,RIGHT
       STRING(''),AT(91,76,11,11),USE(?String35),TRN,RIGHT
       STRING(''),AT(2,91,11,11),USE(?String36),TRN,RIGHT
       STRING(''),AT(16,91,11,11),USE(?String37),TRN,RIGHT
     END
  CODE                                            ! Begin processed code
!Open Calendar Window
  PUSHBIND
   OPEN(Calmo)
  !Set up initial display
   IF PassedDate = ''         !If no date was passed default to current date
     PassedDate=Today()
  END
  MonthNumber = MONTH(PassedDate)
  YearNumber = YEAR(PassedDate)
  DO SetWindowTitle
  DO AssignAllStrings
  DO HighlightPassedDate
  ACCEPT
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
         OF UpKey OROF LeftKey
            MonthNumber -=1
         OF DownKey OROF RightKey
            MonthNumber +=1
         OF PgUpKey
            YearNumber -= 1
         OF PgDnKey
            YearNumber += 1
         OF EscKey                   !Close, returning passed date or default current date
            POPBIND
            RETURN(PassedDate)
         OF MouseRight               !Close, returning passed date or default current date
            POPBIND
            RETURN(PassedDate)
      END!CASE KEYCODE
      IF    MonthNumber > 12
            MonthNumber = 1
            YearNumber +=1
      ELSIF MonthNumber < 1
            MonthNumber = 12
            YearNumber -=1
      END!IF
      DO CheckRange
      DO SetWindowTitle
      DO ClearHighlight
      DO AssignAllStrings
      DO HighlightPassedDate
    END!CASE EVENT
    CASE FIELD()
   OF ?Jan
      CASE EVENT()
      OF EVENT:Accepted
            monthnumber=1
            DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
         END
   OF ?Feb
      CASE EVENT()
      OF EVENT:Accepted
            monthnumber=2
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Mar
      CASE EVENT()
      OF EVENT:Accepted
         monthnumber=3
   
     DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Apr
      CASE EVENT()
      OF EVENT:Accepted
             monthnumber=4
         DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?May
      CASE EVENT()
      OF EVENT:Accepted
         monthnumber=5
         DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Jun
      CASE EVENT()
      OF EVENT:Accepted
           monthnumber=6
          DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
     OF ?Jul
      CASE EVENT()
      OF EVENT:Accepted
         monthnumber=7
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Aug
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=8
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Sep
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=9
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
   OF ?Oct
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=10
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Nov
      CASE EVENT()
      OF EVENT:Accepted
          monthnumber=11
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
    OF ?Dec
      CASE EVENT()
      OF EVENT:Accepted
        monthnumber=12
        DO CheckRange
        DO SetWindowTitle
        DO ClearHighlight
        DO AssignAllStrings
        DO HighlightPassedDate
      END
        OF ?Region1
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String1{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String1{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
         END
      END
    OF ?Region2
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String2{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String2{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region3
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String3{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String3{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region4
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String4{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String4{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region5
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String5{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String5{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region6
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String6{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String6{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region7
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String7{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region8
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String8{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region9
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String9{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region10
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String10{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region11
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String11{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region12
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String12{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region13
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String13{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region14
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String14{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region15
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String15{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region16
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String16{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region17
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String17{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region18
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String18{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region19
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String19{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region20
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String20{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region21
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String21{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region22
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String22{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region23
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String23{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region24
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String24{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region25
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String25{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region26
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String26{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region27
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String27{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region28
      CASE EVENT()
      OF EVENT:Accepted
        POPBIND
        RETURN(DEFORMAT(?String28{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
      END
    OF ?Region29
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String29{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String29{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region30
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String30{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String30{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region31
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String31{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String31{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region32
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String32{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String32{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region33
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String33{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String33{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region34
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String34{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String34{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region35
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String35{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String35{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region36
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String36{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String36{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    OF ?Region37
      CASE EVENT()
      OF EVENT:Accepted
        IF ?String37{PROP:TEXT} <> ''
           POPBIND
           RETURN(DEFORMAT(?String37{PROP:TEXT} &'/' &MonthNumber &'/' &YearNumber,@D6))
        END
      END
    END!CASE FIELD
  END!ACCEPT LOOP
!------------------------------------------------------------------------------------------------
SetWindowTitle ROUTINE
!|Set up the window title
    CASE MonthNumber
         OF  1
             Calmo{PROP:TEXT}='January ' &YearNumber
         OF  2
             Calmo{PROP:TEXT}='February ' &YearNumber
         OF  3
             Calmo{PROP:TEXT}='March ' &YearNumber
         OF  4
             Calmo{PROP:TEXT}='April ' &YearNumber
         OF  5
             Calmo{PROP:TEXT}='May ' &YearNumber
         OF  6
             Calmo{PROP:TEXT}='June ' &YearNumber
         OF  7
             Calmo{PROP:TEXT}='July ' &YearNumber
         OF  8
            Calmo{PROP:TEXT}='August ' &YearNumber
         OF  9
             Calmo{PROP:TEXT}='September ' &YearNumber
         OF  10
             Calmo{PROP:TEXT}='October ' &YearNumber
         OF  11
           Calmo{PROP:TEXT}='November ' &YearNumber
         OF  12
             Calmo{PROP:TEXT}='December ' &YearNumber
    END!CASE
!|----------------------------------------------------------------------------------------------
AssignAllStrings ROUTINE
!|Redraws the calendar for the current month
!|
   !How many days are there in this month?
   CASE MonthNumber
     OF     9                           !Short months
     OROF   4
     OROF   6
     OROF   11
            MaxDays#=30                 
     OF     2                           !If the month is February
            IF YearNumber % 4 = 0       !If a leap year
               MaxDays# = 29            
            ELSE
               MaxDays# = 28
            END!IF
     ELSE   MaxDays# = 31               !Standard months
   END!CASE
   !Find what day the first of this month falls on.
   CASE DEFORMAT(('1/' &MonthNumber &'/' &YearNumber),@D6) % 7
      OF 0                              !Month starts on a Sunday
         ?String1{PROP:TEXT} = '1'      
         ?String2{PROP:TEXT} = '2'
         ?String3{PROP:TEXT} = '3'
         ?String4{PROP:TEXT} = '4'
         ?String5{PROP:TEXT} = '5'
         ?String6{PROP:TEXT} = '6'
         ?String7{PROP:TEXT} = '7'
      OF 1                              !Month starts on a Monday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = '1'
         ?String3{PROP:TEXT} = '2'
         ?String4{PROP:TEXT} = '3'
         ?String5{PROP:TEXT} = '4'
         ?String6{PROP:TEXT} = '5'
         ?String7{PROP:TEXT} = '6'
      OF 2                              !Month starts on a Tuesday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = '1'
         ?String4{PROP:TEXT} = '2'
         ?String5{PROP:TEXT} = '3'
         ?String6{PROP:TEXT} = '4'
         ?String7{PROP:TEXT} = '5'
      OF 3                              !Month starts on a Wednesday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = '1'
         ?String5{PROP:TEXT} = '2'
         ?String6{PROP:TEXT} = '3'
         ?String7{PROP:TEXT} = '4'
      OF 4                              !Month starts on a Thursday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = '1'
         ?String6{PROP:TEXT} = '2'
         ?String7{PROP:TEXT} = '3'
      OF 5                              !Month starts on a Friday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = ''
         ?String6{PROP:TEXT} = '1'
         ?String7{PROP:TEXT} = '2'
      OF 6                              !Month starts on a Saturday
         ?String1{PROP:TEXT} = ''
         ?String2{PROP:TEXT} = ''
         ?String3{PROP:TEXT} = ''
         ?String4{PROP:TEXT} = ''
         ?String5{PROP:TEXT} = ''
         ?String6{PROP:TEXT} = ''
         ?String7{PROP:TEXT} = '1'
   END
  !Format the strings for the rest of the current month.
  !From day 8 to 28 just add 1 to the previous string, then
  !start checking for potential last day of month from string 29 onwards
  ?String8{PROP:TEXT} = DEFORMAT(?String7{PROP:TEXT},@n2) + 1
  ?String9{PROP:TEXT} = DEFORMAT(?String8{PROP:TEXT},@n2) + 1
  ?String10{PROP:TEXT} = DEFORMAT(?String9{PROP:TEXT},@n2) + 1
  ?String11{PROP:TEXT} = DEFORMAT(?String10{PROP:TEXT},@n2) + 1
  ?String12{PROP:TEXT} = DEFORMAT(?String11{PROP:TEXT},@n2) + 1
  ?String13{PROP:TEXT} = DEFORMAT(?String12{PROP:TEXT},@n2) + 1
  ?String14{PROP:TEXT} = DEFORMAT(?String13{PROP:TEXT},@n2) + 1
  ?String15{PROP:TEXT} = DEFORMAT(?String14{PROP:TEXT},@n2) + 1
  ?String16{PROP:TEXT} = DEFORMAT(?String15{PROP:TEXT},@n2) + 1
  ?String17{PROP:TEXT} = DEFORMAT(?String16{PROP:TEXT},@n2) + 1
  ?String18{PROP:TEXT} = DEFORMAT(?String17{PROP:TEXT},@n2) + 1
  ?String19{PROP:TEXT} = DEFORMAT(?String18{PROP:TEXT},@n2) + 1
  ?String20{PROP:TEXT} = DEFORMAT(?String19{PROP:TEXT},@n2) + 1
  ?String21{PROP:TEXT} = DEFORMAT(?String20{PROP:TEXT},@n2) + 1
  ?String22{PROP:TEXT} = DEFORMAT(?String21{PROP:TEXT},@n2) + 1
  ?String23{PROP:TEXT} = DEFORMAT(?String22{PROP:TEXT},@n2) + 1
  ?String24{PROP:TEXT} = DEFORMAT(?String23{PROP:TEXT},@n2) + 1
  ?String25{PROP:TEXT} = DEFORMAT(?String24{PROP:TEXT},@n2) + 1
  ?String26{PROP:TEXT} = DEFORMAT(?String25{PROP:TEXT},@n2) + 1
  ?String27{PROP:TEXT} = DEFORMAT(?String26{PROP:TEXT},@n2) + 1
  ?String28{PROP:TEXT} = DEFORMAT(?String27{PROP:TEXT},@n2) + 1
  IF (DEFORMAT(?String28{PROP:TEXT},@n2) + 1) NOT > Maxdays#
     ?String29{PROP:TEXT} = DEFORMAT(?String28{PROP:TEXT},@n2) + 1
  ELSE
     ?String29{PROP:TEXT} = ''
  END
  IF ?String29{PROP:TEXT} <> '' AND (DEFORMAT(?String29{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String30{PROP:TEXT} = DEFORMAT(?String29{PROP:TEXT},@n2) + 1
  ELSE
     ?String30{PROP:TEXT} = ''
  END
  IF ?String30{PROP:TEXT} <> '' AND (DEFORMAT(?String30{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String31{PROP:TEXT} = DEFORMAT(?String30{PROP:TEXT},@n2) + 1
  ELSE
     ?String31{PROP:TEXT} = ''
  END
  IF ?String31{PROP:TEXT} <> '' AND (DEFORMAT(?String31{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String32{PROP:TEXT} = DEFORMAT(?String31{PROP:TEXT},@n2) + 1
  ELSE
     ?String32{PROP:TEXT} = ''
  END
  IF ?String32{PROP:TEXT} <> '' AND (DEFORMAT(?String32{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String33{PROP:TEXT} = DEFORMAT(?String32{PROP:TEXT},@n2) + 1
  ELSE
     ?String33{PROP:TEXT} = ''
  END
  IF ?String33{PROP:TEXT} <> '' AND (DEFORMAT(?String33{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String34{PROP:TEXT} = DEFORMAT(?String33{PROP:TEXT},@n2) + 1
  ELSE
     ?String34{PROP:TEXT} = ''
  END
  IF ?String34{PROP:TEXT} <> '' AND (DEFORMAT(?String34{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String35{PROP:TEXT} = DEFORMAT(?String34{PROP:TEXT},@n2) + 1
  ELSE
     ?String35{PROP:TEXT} = ''
  END
  IF ?String35{PROP:TEXT} <> '' AND (DEFORMAT(?String35{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String36{PROP:TEXT} = DEFORMAT(?String35{PROP:TEXT},@n2) + 1
  ELSE
     ?String36{PROP:TEXT} = ''
  END
  IF ?String36{PROP:TEXT} <> '' AND (DEFORMAT(?String36{PROP:TEXT},@n2) + 1) NOT > MaxDays#
     ?String37{PROP:TEXT} = DEFORMAT(?String36{PROP:TEXT},@n2) + 1
  ELSE
     ?String37{PROP:TEXT} = ''
  END
!|-------------------------------------------------------------------------------------------
HighlightPassedDate ROUTINE
!| Bevel the region representing the passed date
!|
   IF DAY(PassedDate) > MaxDays# THEN EXIT      !Added this line so if day is
   END                                          !beyond max in new month = no bevel
   CASE DAY(PassedDate)
   OF ?String1{PROP:TEXT}
      ?Region1{PROP:BEVEL} = -1
   OF ?String2{PROP:TEXT}
      ?Region2{PROP:BEVEL} = -1
   OF ?String3{PROP:TEXT}
      ?Region3{PROP:BEVEL} = -1
   OF ?String4{PROP:TEXT}
      ?Region4{PROP:BEVEL} = -1
   OF ?String5{PROP:TEXT}
      ?Region5{PROP:BEVEL} = -1
   OF ?String6{PROP:TEXT}
      ?Region6{PROP:BEVEL} = -1
   OF ?String7{PROP:TEXT}
      ?Region7{PROP:BEVEL} = -1
   OF ?String8{PROP:TEXT}
      ?Region8{PROP:BEVEL} = -1
   OF ?String9{PROP:TEXT}
      ?Region9{PROP:BEVEL} = -1
   OF ?String10{PROP:TEXT}
      ?Region10{PROP:BEVEL} = -1
   OF ?String11{PROP:TEXT}
      ?Region11{PROP:BEVEL} = -1
   OF ?String12{PROP:TEXT}
      ?Region12{PROP:BEVEL} = -1
   OF ?String13{PROP:TEXT}
      ?Region13{PROP:BEVEL} = -1
   OF ?String14{PROP:TEXT}
      ?Region14{PROP:BEVEL} = -1
   OF ?String15{PROP:TEXT}
      ?Region15{PROP:BEVEL} = -1
   OF ?String16{PROP:TEXT}
      ?Region16{PROP:BEVEL} = -1
   OF ?String17{PROP:TEXT}
      ?Region17{PROP:BEVEL} = -1
   OF ?String18{PROP:TEXT}
      ?Region18{PROP:BEVEL} = -1
   OF ?String19{PROP:TEXT}
      ?Region19{PROP:BEVEL} = -1
   OF ?String20{PROP:TEXT}
      ?Region20{PROP:BEVEL} = -1
   OF ?String21{PROP:TEXT}
      ?Region21{PROP:BEVEL} = -1
   OF ?String22{PROP:TEXT}
      ?Region22{PROP:BEVEL} = -1
   OF ?String23{PROP:TEXT}
      ?Region23{PROP:BEVEL} = -1
   OF ?String24{PROP:TEXT}
      ?Region24{PROP:BEVEL} = -1
   OF ?String25{PROP:TEXT}
      ?Region25{PROP:BEVEL} = -1
   OF ?String26{PROP:TEXT}
      ?Region26{PROP:BEVEL} = -1
   OF ?String27{PROP:TEXT}
      ?Region27{PROP:BEVEL} = -1
   OF ?String28{PROP:TEXT}
      ?Region28{PROP:BEVEL} = -1
   OF ?String29{PROP:TEXT}
      ?Region29{PROP:BEVEL} = -1
   OF ?String30{PROP:TEXT}
      ?Region30{PROP:BEVEL} = -1
   OF ?String31{PROP:TEXT}
      ?Region31{PROP:BEVEL} = -1
   OF ?String32{PROP:TEXT}
      ?Region32{PROP:BEVEL} = -1
   OF ?String33{PROP:TEXT}
      ?Region33{PROP:BEVEL} = -1
   OF ?String34{PROP:TEXT}
      ?Region34{PROP:BEVEL} = -1
   OF ?String35{PROP:TEXT}
      ?Region35{PROP:BEVEL} = -1
   OF ?String36{PROP:TEXT}
      ?Region36{PROP:BEVEL} = -1
   OF ?String37{PROP:TEXT}
      ?Region37{PROP:BEVEL} = -1
   END!CASE
!|--------------------------------------------------------------------------------------------
ClearHighlight ROUTINE
!| Clear any Bevels
!|
   IF ?Region1{PROP:BEVEL} <> 0 THEN ?Region1{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region2{PROP:BEVEL} <> 0 THEN ?Region2{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region3{PROP:BEVEL} <> 0 THEN ?Region3{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region4{PROP:BEVEL} <> 0 THEN ?Region4{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region5{PROP:BEVEL} <> 0 THEN ?Region5{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region6{PROP:BEVEL} <> 0 THEN ?Region6{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region7{PROP:BEVEL} <> 0 THEN ?Region7{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region8{PROP:BEVEL} <> 0 THEN ?Region8{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region9{PROP:BEVEL} <> 0 THEN ?Region9{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region10{PROP:BEVEL} <> 0 THEN ?Region10{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region11{PROP:BEVEL} <> 0 THEN ?Region11{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region12{PROP:BEVEL} <> 0 THEN ?Region12{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region13{PROP:BEVEL} <> 0 THEN ?Region13{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region14{PROP:BEVEL} <> 0 THEN ?Region14{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region15{PROP:BEVEL} <> 0 THEN ?Region15{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region16{PROP:BEVEL} <> 0 THEN ?Region16{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region17{PROP:BEVEL} <> 0 THEN ?Region17{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region18{PROP:BEVEL} <> 0 THEN ?Region18{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region19{PROP:BEVEL} <> 0 THEN ?Region19{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region20{PROP:BEVEL} <> 0 THEN ?Region20{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region21{PROP:BEVEL} <> 0 THEN ?Region21{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region22{PROP:BEVEL} <> 0 THEN ?Region22{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region23{PROP:BEVEL} <> 0 THEN ?Region23{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region24{PROP:BEVEL} <> 0 THEN ?Region24{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region25{PROP:BEVEL} <> 0 THEN ?Region25{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region26{PROP:BEVEL} <> 0 THEN ?Region26{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region27{PROP:BEVEL} <> 0 THEN ?Region27{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region28{PROP:BEVEL} <> 0 THEN ?Region28{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region29{PROP:BEVEL} <> 0 THEN ?Region29{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region30{PROP:BEVEL} <> 0 THEN ?Region30{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region31{PROP:BEVEL} <> 0 THEN ?Region31{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region32{PROP:BEVEL} <> 0 THEN ?Region32{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region33{PROP:BEVEL} <> 0 THEN ?Region33{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region34{PROP:BEVEL} <> 0 THEN ?Region34{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region35{PROP:BEVEL} <> 0 THEN ?Region35{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region36{PROP:BEVEL} <> 0 THEN ?Region36{PROP:BEVEL} = 0
      EXIT
   END
   IF ?Region37{PROP:BEVEL} <> 0 THEN ?Region37{PROP:BEVEL} = 0
      EXIT
   END
!|---------------------------------------------------------======------------------
CheckRange ROUTINE
!|Gives error message if year is out of range
!|
  IF    YearNumber < 1801
        YearNumber = 1801
        MESSAGE('You cannot use the calendar for<13,10>'&|
        'dates before the year 1801', |
        'Date Out Of Range', Icon:Asterisk, |
        Button:Ok, Button:Ok, 0)
  ELSIF YearNumber > 2099
        YearNumber = 2099
        MESSAGE('You cannot use the calendar for<13,10>'&|
        'dates after the year 2099', |
        'Date Out Of Range', Icon:Asterisk, |
        Button:Ok, Button:Ok, 0)
  END
!|-----------------------------------------------------------------------------